/* Color.c generated by valac 0.56.18, the Vala compiler
 * generated from Color.vala, do not modify */

/*
 * Copyright 2019-2021 elementary, Inc. (https://elementary.io)
 * Copyright 2011–2013 Robert Dyer
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "gala.h"
#include <gdk/gdk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_DRAWING_COLOR_0_PROPERTY,
	GALA_DRAWING_COLOR_NUM_PROPERTIES
};
static GParamSpec* gala_drawing_color_properties[GALA_DRAWING_COLOR_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static gpointer gala_drawing_color_parent_class = NULL;

static void gala_drawing_color_set_from_rgba (GalaDrawingColor* self,
                                       GdkRGBA* color);
static void gala_drawing_color_rgb_to_hsv (GalaDrawingColor* self,
                                    gdouble r,
                                    gdouble g,
                                    gdouble b,
                                    gdouble* h,
                                    gdouble* s,
                                    gdouble* v);
static void gala_drawing_color_hsv_to_rgb (GalaDrawingColor* self,
                                    gdouble h,
                                    gdouble s,
                                    gdouble v,
                                    gdouble* r,
                                    gdouble* g,
                                    gdouble* b);
static void gala_drawing_color_finalize (GObject * obj);
static GType gala_drawing_color_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

const GdkRGBA GALA_DRAWING_COLOR_LIGHT_BACKGROUND = {(gdouble) (250.f / 255.f), (gdouble) (250.f / 255.f), (gdouble) (250.f / 255.f), (gdouble) 1};
const GdkRGBA GALA_DRAWING_COLOR_DARK_BACKGROUND = {(gdouble) (51 / 255.f), (gdouble) (51 / 255.f), (gdouble) (51 / 255.f), (gdouble) 1};
const GdkRGBA GALA_DRAWING_COLOR_LIGHT_BORDER = {(gdouble) 0, (gdouble) 0, (gdouble) 0, 0.2};
const GdkRGBA GALA_DRAWING_COLOR_DARK_BORDER = {(gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75};
const GdkRGBA GALA_DRAWING_COLOR_LIGHT_HIGHLIGHT = {(gdouble) 255, (gdouble) 255, (gdouble) 255, (gdouble) 1};
const GdkRGBA GALA_DRAWING_COLOR_DARK_HIGHLIGHT = {(gdouble) 255, (gdouble) 255, (gdouble) 255, 0.05};
const GdkRGBA GALA_DRAWING_COLOR_TOOLTIP_BACKGROUND = {(gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 1};
const GdkRGBA GALA_DRAWING_COLOR_TOOLTIP_TEXT_COLOR = {(gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1};

/**
        * Extracts the alpha value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the alpha channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_alpha_from_int (gint color)
{
	guint8 result;
#line 50 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 24) & 0xFF);
#line 50 "../lib/Drawing/Color.vala"
	return result;
#line 90 "Color.c"
}

/**
        * Extracts the red value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the red channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_red_from_int (gint color)
{
	guint8 result;
#line 60 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 16) & 0xFF);
#line 60 "../lib/Drawing/Color.vala"
	return result;
#line 107 "Color.c"
}

/**
        * Extracts the green value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the green channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_green_from_int (gint color)
{
	guint8 result;
#line 70 "../lib/Drawing/Color.vala"
	result = (guint8) ((color >> 8) & 0xFF);
#line 70 "../lib/Drawing/Color.vala"
	return result;
#line 124 "Color.c"
}

/**
        * Extracts the blue value from the integer value
        * serialized by {@link Gala.Drawing.Color.to_int}.
        *
        * @return the blue channel value as a uint8 ranging from 0 - 255.
        */
guint8
gala_drawing_color_blue_from_int (gint color)
{
	guint8 result;
#line 80 "../lib/Drawing/Color.vala"
	result = (guint8) (color & 0xFF);
#line 80 "../lib/Drawing/Color.vala"
	return result;
#line 141 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} with the supplied values.
        *
        * @param R the value of the red channel as a double
        * @param G the value of the green channel as a double
        * @param B the value of the blue channel as a double
        * @param A the value of the alpha channel as a double
        */
GalaDrawingColor*
gala_drawing_color_construct (GType object_type,
                              gdouble R,
                              gdouble G,
                              gdouble B,
                              gdouble A)
{
	GalaDrawingColor * self = NULL;
#line 91 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 92 "../lib/Drawing/Color.vala"
	self->R = R;
#line 93 "../lib/Drawing/Color.vala"
	self->G = G;
#line 94 "../lib/Drawing/Color.vala"
	self->B = B;
#line 95 "../lib/Drawing/Color.vala"
	self->A = A;
#line 91 "../lib/Drawing/Color.vala"
	return self;
#line 172 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new (gdouble R,
                        gdouble G,
                        gdouble B,
                        gdouble A)
{
#line 91 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct (GALA_DRAWING_TYPE_COLOR, R, G, B, A);
#line 183 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from a {@link Gdk.RGBA}.
        *
        * @param color the {@link Gdk.RGBA}
        */
GalaDrawingColor*
gala_drawing_color_construct_from_rgba (GType object_type,
                                        GdkRGBA* color)
{
	GalaDrawingColor * self = NULL;
	GdkRGBA _tmp0_;
#line 103 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 103 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 104 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 104 "../lib/Drawing/Color.vala"
	gala_drawing_color_set_from_rgba (self, &_tmp0_);
#line 103 "../lib/Drawing/Color.vala"
	return self;
#line 207 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_rgba (GdkRGBA* color)
{
#line 103 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_rgba (GALA_DRAWING_TYPE_COLOR, color);
#line 215 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from a string.
        *
        * The string can be either one of:
        *
        * * A standard name (Taken from the X11 rgb.txt file).
        * * A hexadecimal value in the form “#rgb”, “#rrggbb”, “#rrrgggbbb” or ”#rrrrggggbbbb”
        * * A RGB color in the form “rgb(r,g,b)” (In this case the color will have full opacity)
        * * A RGBA color in the form “rgba(r,g,b,a)”
        *
        * For more details on formatting and how this function works see {@link Gdk.RGBA.parse}
        *
        * @param color the string specifying the color
        */
GalaDrawingColor*
gala_drawing_color_construct_from_string (GType object_type,
                                          const gchar* color)
{
	GalaDrawingColor * self = NULL;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
#line 121 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 121 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 122 "../lib/Drawing/Color.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 123 "../lib/Drawing/Color.vala"
	gdk_rgba_parse (&rgba, color);
#line 124 "../lib/Drawing/Color.vala"
	_tmp0_ = rgba;
#line 124 "../lib/Drawing/Color.vala"
	gala_drawing_color_set_from_rgba (self, &_tmp0_);
#line 121 "../lib/Drawing/Color.vala"
	return self;
#line 253 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_string (const gchar* color)
{
#line 121 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_string (GALA_DRAWING_TYPE_COLOR, color);
#line 261 "Color.c"
}

/**
        * Constructs a new {@link Gala.Drawing.Color} from an integer.
        *
        * This constructor should be used when deserializing the previously serialized
        * color by {@link Gala.Drawing.Color.to_int}.
        *
        * For more details on what format the color integer representation has, see {@link Gala.Drawing.Color.to_int}.
        *
        * If you would like to deserialize the A, R, G and B values from the integer without
        * creating a new instance of {@link Gala.Drawing.Color}, you can use the available
        * //*_from_int// static method collection such as {@link Gala.Drawing.Color.alpha_from_int}.
        *
        * @param color the integer specyfying the color
        */
GalaDrawingColor*
gala_drawing_color_construct_from_int (GType object_type,
                                       gint color)
{
	GalaDrawingColor * self = NULL;
#line 141 "../lib/Drawing/Color.vala"
	self = (GalaDrawingColor*) g_object_new (object_type, NULL);
#line 142 "../lib/Drawing/Color.vala"
	self->R = ((gdouble) gala_drawing_color_red_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 143 "../lib/Drawing/Color.vala"
	self->G = ((gdouble) gala_drawing_color_green_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 144 "../lib/Drawing/Color.vala"
	self->B = ((gdouble) gala_drawing_color_blue_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 145 "../lib/Drawing/Color.vala"
	self->A = ((gdouble) gala_drawing_color_alpha_from_int (color)) / ((gdouble) G_MAXUINT8);
#line 141 "../lib/Drawing/Color.vala"
	return self;
#line 295 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_new_from_int (gint color)
{
#line 141 "../lib/Drawing/Color.vala"
	return gala_drawing_color_construct_from_int (GALA_DRAWING_TYPE_COLOR, color);
#line 303 "Color.c"
}

/**
        * Changes the hue of this color to the supplied one.
        *
        * @param hue the hue to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 161 "../lib/Drawing/Color.vala"
	return self ? g_object_ref (self) : NULL;
#line 318 "Color.c"
}

GalaDrawingColor*
gala_drawing_color_set_hue (GalaDrawingColor* self,
                            gdouble hue)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 155 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 155 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((hue >= ((gdouble) 0)) && (hue <= ((gdouble) 360)), "hue >= 0 && hue <= 360", NULL);
#line 157 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 157 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 157 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 157 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 158 "../lib/Drawing/Color.vala"
	h = hue;
#line 159 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 159 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 159 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 159 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 161 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 161 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 161 "../lib/Drawing/Color.vala"
	return result;
#line 364 "Color.c"
}

/**
        * Changes the saturation of this color to the supplied one.
        *
        * @param sat the saturation to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_sat (GalaDrawingColor* self,
                            gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 171 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 173 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 173 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 173 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 173 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 174 "../lib/Drawing/Color.vala"
	s = sat;
#line 175 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 175 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 175 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 175 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 177 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 177 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 177 "../lib/Drawing/Color.vala"
	return result;
#line 417 "Color.c"
}

/**
        * Changes the value of this color to the supplied one.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_val (GalaDrawingColor* self,
                            gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 187 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 189 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 189 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 189 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 189 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 190 "../lib/Drawing/Color.vala"
	v = val;
#line 191 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 191 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 191 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 191 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 193 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 193 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 193 "../lib/Drawing/Color.vala"
	return result;
#line 470 "Color.c"
}

/**
        * Changes the value of the alpha channel.
        *
        * @param alpha the value of the alpha channel
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_alpha (GalaDrawingColor* self,
                              gdouble alpha)
{
	GalaDrawingColor* _tmp0_;
	GalaDrawingColor* result;
#line 203 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((alpha >= ((gdouble) 0)) && (alpha <= ((gdouble) 1)), "alpha >= 0 && alpha <= 1", NULL);
#line 204 "../lib/Drawing/Color.vala"
	self->A = alpha;
#line 205 "../lib/Drawing/Color.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 205 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 205 "../lib/Drawing/Color.vala"
	return result;
#line 498 "Color.c"
}

/**
        * Get the value.
        * @return the hue of this color, as a double value
        */
gdouble
gala_drawing_color_get_hue (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 212 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 214 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 214 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 214 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 214 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 215 "../lib/Drawing/Color.vala"
	result = h;
#line 215 "../lib/Drawing/Color.vala"
	return result;
#line 529 "Color.c"
}

/**
        * Get the value.
        * @return the saturation of this color, as a double value
        */
gdouble
gala_drawing_color_get_sat (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 222 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 224 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 224 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 224 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 224 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 225 "../lib/Drawing/Color.vala"
	result = s;
#line 225 "../lib/Drawing/Color.vala"
	return result;
#line 560 "Color.c"
}

/**
        * Get the value.
        *
        * @return the value of this color, as a double value
        */
gdouble
gala_drawing_color_get_val (GalaDrawingColor* self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 233 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 235 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 235 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 235 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 235 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 236 "../lib/Drawing/Color.vala"
	result = v;
#line 236 "../lib/Drawing/Color.vala"
	return result;
#line 592 "Color.c"
}

/**
        * Adds the supplied hue value to this color's hue value.
        *
        * @param val the hue to add to this color's hue
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_add_hue (GalaDrawingColor* self,
                            gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 246 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 248 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 248 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 248 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 249 "../lib/Drawing/Color.vala"
	h = fmod (fmod (h + val, 360) + 360, 360);
#line 250 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 250 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 250 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 250 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 252 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 252 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 252 "../lib/Drawing/Color.vala"
	return result;
#line 643 "Color.c"
}

/**
        * Changes this color's saturation to the supplied saturation, if it is greater than this color's saturation.
        *
        * @param sat the saturation to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_min_sat (GalaDrawingColor* self,
                                gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 262 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 262 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 264 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 264 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 264 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 264 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 265 "../lib/Drawing/Color.vala"
	s = MAX (s, sat);
#line 266 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 266 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 266 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 266 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 268 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 268 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 268 "../lib/Drawing/Color.vala"
	return result;
#line 696 "Color.c"
}

/**
        * Changes this color's value to the supplied value, if it is greater than this color's value.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_min_value (GalaDrawingColor* self,
                                  gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 278 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 278 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 280 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 280 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 280 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 280 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 281 "../lib/Drawing/Color.vala"
	v = MAX (v, val);
#line 282 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 282 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 282 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 282 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 284 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 284 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 284 "../lib/Drawing/Color.vala"
	return result;
#line 749 "Color.c"
}

/**
        * Changes this color's saturation to the supplied saturation, if it is smaller than this color's saturation.
        *
        * @param sat the hue to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_max_sat (GalaDrawingColor* self,
                                gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 294 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 294 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1", NULL);
#line 296 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 296 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 296 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 296 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 297 "../lib/Drawing/Color.vala"
	s = MIN (s, sat);
#line 298 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 298 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 298 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 298 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 300 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 300 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 300 "../lib/Drawing/Color.vala"
	return result;
#line 802 "Color.c"
}

/**
        * Changes this color's value to the supplied value, if it is smaller than this color's value.
        *
        * @param val the value to change this color to
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_set_max_val (GalaDrawingColor* self,
                                gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 310 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1", NULL);
#line 312 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 312 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 312 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 312 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 313 "../lib/Drawing/Color.vala"
	v = MIN (v, val);
#line 314 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 314 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 314 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 314 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 316 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 316 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 316 "../lib/Drawing/Color.vala"
	return result;
#line 855 "Color.c"
}

/**
        * Multiplies this color's saturation by the supplied amount.
        *
        * @param amount the amount to multiply the saturation by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_multiply_sat (GalaDrawingColor* self,
                                 gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 326 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail (amount >= ((gdouble) 0), "amount >= 0", NULL);
#line 328 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 328 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 328 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 328 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 329 "../lib/Drawing/Color.vala"
	s = MIN ((gdouble) 1, s * amount);
#line 330 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 330 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 330 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 330 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 332 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 332 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 332 "../lib/Drawing/Color.vala"
	return result;
#line 908 "Color.c"
}

/**
        * Brightens this color's value by the supplied amount.
        *
        * @param amount the amount to brighten the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_brighten_val (GalaDrawingColor* self,
                                 gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 342 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 344 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 344 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 344 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 344 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 345 "../lib/Drawing/Color.vala"
	v = MIN ((gdouble) 1, v + ((1 - v) * amount));
#line 346 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 346 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 346 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 346 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 348 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 348 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 348 "../lib/Drawing/Color.vala"
	return result;
#line 961 "Color.c"
}

/**
        * Darkens this color's value by the supplied amount.
        *
        * @param amount the amount to darken the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_darken_val (GalaDrawingColor* self,
                               gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 358 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 358 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 360 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 360 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 360 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 360 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 361 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - ((1 - v) * amount));
#line 362 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 362 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 362 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 362 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 364 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 364 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 364 "../lib/Drawing/Color.vala"
	return result;
#line 1014 "Color.c"
}

/**
        * Darkens this color's value by the supplied amount * color's saturation.
        *
        * @param amount the amount to darken the value by
        *
        * @return the new {@link Gala.Drawing.Color}
        */
GalaDrawingColor*
gala_drawing_color_darken_by_sat (GalaDrawingColor* self,
                                  gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	GalaDrawingColor* _tmp6_;
	GalaDrawingColor* result;
#line 374 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "../lib/Drawing/Color.vala"
	_vala_return_val_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1", NULL);
#line 376 "../lib/Drawing/Color.vala"
	gala_drawing_color_rgb_to_hsv (self, self->R, self->G, self->B, &_tmp0_, &_tmp1_, &_tmp2_);
#line 376 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 376 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 376 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 377 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - (amount * s));
#line 378 "../lib/Drawing/Color.vala"
	gala_drawing_color_hsv_to_rgb (self, h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 378 "../lib/Drawing/Color.vala"
	self->R = _tmp3_;
#line 378 "../lib/Drawing/Color.vala"
	self->G = _tmp4_;
#line 378 "../lib/Drawing/Color.vala"
	self->B = _tmp5_;
#line 380 "../lib/Drawing/Color.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 380 "../lib/Drawing/Color.vala"
	result = _tmp6_;
#line 380 "../lib/Drawing/Color.vala"
	return result;
#line 1067 "Color.c"
}

static void
gala_drawing_color_rgb_to_hsv (GalaDrawingColor* self,
                               gdouble r,
                               gdouble g,
                               gdouble b,
                               gdouble* h,
                               gdouble* s,
                               gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble min = 0.0;
	gdouble max = 0.0;
	gdouble delta = 0.0;
#line 383 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 383 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
#line 383 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
#line 383 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
#line 386 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 387 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 389 "../lib/Drawing/Color.vala"
	_vala_v = max;
#line 390 "../lib/Drawing/Color.vala"
	if (_vala_v == ((gdouble) 0)) {
#line 391 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 392 "../lib/Drawing/Color.vala"
		_vala_s = (gdouble) 0;
#line 393 "../lib/Drawing/Color.vala"
		if (h) {
#line 393 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1109 "Color.c"
		}
#line 393 "../lib/Drawing/Color.vala"
		if (s) {
#line 393 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1115 "Color.c"
		}
#line 393 "../lib/Drawing/Color.vala"
		if (v) {
#line 393 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1121 "Color.c"
		}
#line 393 "../lib/Drawing/Color.vala"
		return;
#line 1125 "Color.c"
	}
#line 397 "../lib/Drawing/Color.vala"
	r = r / _vala_v;
#line 398 "../lib/Drawing/Color.vala"
	g = g / _vala_v;
#line 399 "../lib/Drawing/Color.vala"
	b = b / _vala_v;
#line 401 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 402 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 404 "../lib/Drawing/Color.vala"
	delta = max - min;
#line 405 "../lib/Drawing/Color.vala"
	_vala_s = delta;
#line 406 "../lib/Drawing/Color.vala"
	if (_vala_s == ((gdouble) 0)) {
#line 407 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 408 "../lib/Drawing/Color.vala"
		if (h) {
#line 408 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1149 "Color.c"
		}
#line 408 "../lib/Drawing/Color.vala"
		if (s) {
#line 408 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1155 "Color.c"
		}
#line 408 "../lib/Drawing/Color.vala"
		if (v) {
#line 408 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1161 "Color.c"
		}
#line 408 "../lib/Drawing/Color.vala"
		return;
#line 1165 "Color.c"
	}
#line 412 "../lib/Drawing/Color.vala"
	r = (r - min) / delta;
#line 413 "../lib/Drawing/Color.vala"
	g = (g - min) / delta;
#line 414 "../lib/Drawing/Color.vala"
	b = (b - min) / delta;
#line 416 "../lib/Drawing/Color.vala"
	if (max == r) {
#line 417 "../lib/Drawing/Color.vala"
		_vala_h = 0 + (60 * (g - b));
#line 418 "../lib/Drawing/Color.vala"
		if (_vala_h < ((gdouble) 0)) {
#line 419 "../lib/Drawing/Color.vala"
			_vala_h = _vala_h + 360;
#line 1181 "Color.c"
		}
	} else {
#line 420 "../lib/Drawing/Color.vala"
		if (max == g) {
#line 421 "../lib/Drawing/Color.vala"
			_vala_h = 120 + (60 * (b - r));
#line 1188 "Color.c"
		} else {
#line 423 "../lib/Drawing/Color.vala"
			_vala_h = 240 + (60 * (r - g));
#line 1192 "Color.c"
		}
	}
#line 383 "../lib/Drawing/Color.vala"
	if (h) {
#line 383 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 1199 "Color.c"
	}
#line 383 "../lib/Drawing/Color.vala"
	if (s) {
#line 383 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 1205 "Color.c"
	}
#line 383 "../lib/Drawing/Color.vala"
	if (v) {
#line 383 "../lib/Drawing/Color.vala"
		*v = _vala_v;
#line 1211 "Color.c"
	}
}

static void
gala_drawing_color_hsv_to_rgb (GalaDrawingColor* self,
                               gdouble h,
                               gdouble s,
                               gdouble v,
                               gdouble* r,
                               gdouble* g,
                               gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
#line 427 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 427 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h <= ((gdouble) 360)), "h >= 0 && h <= 360");
#line 427 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
#line 427 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((v >= ((gdouble) 0)) && (v <= ((gdouble) 1)), "v >= 0 && v <= 1");
#line 430 "../lib/Drawing/Color.vala"
	_vala_r = (gdouble) 0;
#line 431 "../lib/Drawing/Color.vala"
	_vala_g = (gdouble) 0;
#line 432 "../lib/Drawing/Color.vala"
	_vala_b = (gdouble) 0;
#line 434 "../lib/Drawing/Color.vala"
	if (s == ((gdouble) 0)) {
#line 435 "../lib/Drawing/Color.vala"
		_vala_r = v;
#line 436 "../lib/Drawing/Color.vala"
		_vala_g = v;
#line 437 "../lib/Drawing/Color.vala"
		_vala_b = v;
#line 1249 "Color.c"
	} else {
		gint sec_num = 0;
		gdouble frac_sec = 0.0;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble t = 0.0;
#line 439 "../lib/Drawing/Color.vala"
		sec_num = (gint) floor (h / 60);
#line 440 "../lib/Drawing/Color.vala"
		frac_sec = (h / 60.0) - sec_num;
#line 442 "../lib/Drawing/Color.vala"
		p = v * (1 - s);
#line 443 "../lib/Drawing/Color.vala"
		q = v * (1 - (s * frac_sec));
#line 444 "../lib/Drawing/Color.vala"
		t = v * (1 - (s * (1 - frac_sec)));
#line 446 "../lib/Drawing/Color.vala"
		switch (sec_num) {
#line 446 "../lib/Drawing/Color.vala"
			case 0:
#line 1270 "Color.c"
			{
#line 448 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 449 "../lib/Drawing/Color.vala"
				_vala_g = t;
#line 450 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 451 "../lib/Drawing/Color.vala"
				break;
#line 1280 "Color.c"
			}
#line 446 "../lib/Drawing/Color.vala"
			case 1:
#line 1284 "Color.c"
			{
#line 453 "../lib/Drawing/Color.vala"
				_vala_r = q;
#line 454 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 455 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 456 "../lib/Drawing/Color.vala"
				break;
#line 1294 "Color.c"
			}
#line 446 "../lib/Drawing/Color.vala"
			case 2:
#line 1298 "Color.c"
			{
#line 458 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 459 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 460 "../lib/Drawing/Color.vala"
				_vala_b = t;
#line 461 "../lib/Drawing/Color.vala"
				break;
#line 1308 "Color.c"
			}
#line 446 "../lib/Drawing/Color.vala"
			case 3:
#line 1312 "Color.c"
			{
#line 463 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 464 "../lib/Drawing/Color.vala"
				_vala_g = q;
#line 465 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 466 "../lib/Drawing/Color.vala"
				break;
#line 1322 "Color.c"
			}
#line 446 "../lib/Drawing/Color.vala"
			case 4:
#line 1326 "Color.c"
			{
#line 468 "../lib/Drawing/Color.vala"
				_vala_r = t;
#line 469 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 470 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 471 "../lib/Drawing/Color.vala"
				break;
#line 1336 "Color.c"
			}
#line 446 "../lib/Drawing/Color.vala"
			case 5:
#line 1340 "Color.c"
			{
#line 473 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 474 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 475 "../lib/Drawing/Color.vala"
				_vala_b = q;
#line 476 "../lib/Drawing/Color.vala"
				break;
#line 1350 "Color.c"
			}
			default:
#line 446 "../lib/Drawing/Color.vala"
			break;
#line 1355 "Color.c"
		}
	}
#line 427 "../lib/Drawing/Color.vala"
	if (r) {
#line 427 "../lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1362 "Color.c"
	}
#line 427 "../lib/Drawing/Color.vala"
	if (g) {
#line 427 "../lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1368 "Color.c"
	}
#line 427 "../lib/Drawing/Color.vala"
	if (b) {
#line 427 "../lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1374 "Color.c"
	}
}

/**
        * {@inheritDoc}
        */
gchar*
gala_drawing_color_settings_serialize (GalaDrawingColor* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 484 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 485 "../lib/Drawing/Color.vala"
	_tmp0_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (self->R * G_MAXUINT8), (gint) (self->G * G_MAXUINT8), (gint) (self->B * G_MAXUINT8), (gint) (self->A * G_MAXUINT8));
#line 485 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 485 "../lib/Drawing/Color.vala"
	return result;
#line 1394 "Color.c"
}

/**
        * {@inheritDoc}
        */
void
gala_drawing_color_settings_deserialize (GalaDrawingColor* self,
                                         const gchar* s)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 494 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 494 "../lib/Drawing/Color.vala"
	g_return_if_fail (s != NULL);
#line 495 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_ = g_strsplit (s, ";;", 0);
#line 495 "../lib/Drawing/Color.vala"
	parts = _tmp1_;
#line 495 "../lib/Drawing/Color.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 495 "../lib/Drawing/Color.vala"
	_parts_size_ = parts_length1;
#line 497 "../lib/Drawing/Color.vala"
	_tmp2_ = parts[0];
#line 497 "../lib/Drawing/Color.vala"
	self->R = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp2_))) / G_MAXUINT8;
#line 498 "../lib/Drawing/Color.vala"
	_tmp3_ = parts[1];
#line 498 "../lib/Drawing/Color.vala"
	self->G = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp3_))) / G_MAXUINT8;
#line 499 "../lib/Drawing/Color.vala"
	_tmp4_ = parts[2];
#line 499 "../lib/Drawing/Color.vala"
	self->B = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp4_))) / G_MAXUINT8;
#line 500 "../lib/Drawing/Color.vala"
	_tmp5_ = parts[3];
#line 500 "../lib/Drawing/Color.vala"
	self->A = MIN ((gdouble) G_MAXUINT8, MAX ((gdouble) 0, (gdouble) atoi (_tmp5_))) / G_MAXUINT8;
#line 494 "../lib/Drawing/Color.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1443 "Color.c"
}

/**
        * Returns a textual specification of this in the form `rgb (r, g, b)` or `rgba (r, g, b, a)`,
        * where “r”, “g”, “b” and “a” represent the red, green, blue and alpha values respectively.
        *
        * r, g, and b are represented as integers in the range 0 to 255, and a is represented as
        * floating point value in the range 0 to 1.
        *
        * Note: that this string representation may lose some precision, since r, g and b are represented
        * as 8-bit integers. If this is a concern, you should use a different representation.
        *
        * This returns the same string as a {@link Gdk.RGBA} would return in {@link Gdk.RGBA.to_string}
        *
        * @return the text string
        */
gchar*
gala_drawing_color_to_string (GalaDrawingColor* self)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* result;
#line 517 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 518 "../lib/Drawing/Color.vala"
	_tmp0_.red = (gdouble) ((gfloat) self->R);
#line 518 "../lib/Drawing/Color.vala"
	_tmp0_.green = (gdouble) ((gfloat) self->G);
#line 518 "../lib/Drawing/Color.vala"
	_tmp0_.blue = (gdouble) ((gfloat) self->B);
#line 518 "../lib/Drawing/Color.vala"
	_tmp0_.alpha = (gdouble) ((gfloat) self->A);
#line 518 "../lib/Drawing/Color.vala"
	rgba = _tmp0_;
#line 519 "../lib/Drawing/Color.vala"
	_tmp1_ = gdk_rgba_to_string (&rgba);
#line 519 "../lib/Drawing/Color.vala"
	result = _tmp1_;
#line 519 "../lib/Drawing/Color.vala"
	return result;
#line 1485 "Color.c"
}

/**
        * Converts this to a 32 bit integer.
        *
        * This function can be useful for serializing the color so that it can be stored
        * and retrieved easily with hash tables and lists.
        *
        * The returned integer will contain the four channels
        * that define the {@link Gala.Drawing.Color} class: alpha, red, green and blue.
        *
        * Each channel is represented by 8 bits.
        * The first 8 bits of the integer conatin the alpha channel while all other 24 bits represent
        * red, green and blue channels respectively.
        *
        * The format written as a string would look like this:
        *
        * //AAAAAAAA RRRRRRRR GGGGGGGG BBBBBBBB//
        *
        * where //A// is one bit of alpha chnnel, //R// of red channel, //G// of green channel and //B// of blue channel.
        *
        * @return a 32 bit integer representing this
        */
gint
gala_drawing_color_to_int (GalaDrawingColor* self)
{
	guint8 red = 0U;
	guint8 green = 0U;
	guint8 blue = 0U;
	guint8 alpha = 0U;
	gint result;
#line 543 "../lib/Drawing/Color.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 544 "../lib/Drawing/Color.vala"
	red = (guint8) (self->R * G_MAXUINT8);
#line 545 "../lib/Drawing/Color.vala"
	green = (guint8) (self->G * G_MAXUINT8);
#line 546 "../lib/Drawing/Color.vala"
	blue = (guint8) (self->B * G_MAXUINT8);
#line 547 "../lib/Drawing/Color.vala"
	alpha = (guint8) (self->A * G_MAXUINT8);
#line 549 "../lib/Drawing/Color.vala"
	result = (((alpha << 24) | (red << 16)) | (green << 8)) | blue;
#line 549 "../lib/Drawing/Color.vala"
	return result;
#line 1531 "Color.c"
}

static void
gala_drawing_color_set_from_rgba (GalaDrawingColor* self,
                                  GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
#line 552 "../lib/Drawing/Color.vala"
	g_return_if_fail (self != NULL);
#line 552 "../lib/Drawing/Color.vala"
	g_return_if_fail (color != NULL);
#line 553 "../lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 553 "../lib/Drawing/Color.vala"
	self->R = _tmp0_.red;
#line 554 "../lib/Drawing/Color.vala"
	_tmp1_ = *color;
#line 554 "../lib/Drawing/Color.vala"
	self->G = _tmp1_.green;
#line 555 "../lib/Drawing/Color.vala"
	_tmp2_ = *color;
#line 555 "../lib/Drawing/Color.vala"
	self->B = _tmp2_.blue;
#line 556 "../lib/Drawing/Color.vala"
	_tmp3_ = *color;
#line 556 "../lib/Drawing/Color.vala"
	self->A = _tmp3_.alpha;
#line 1562 "Color.c"
}

static void
gala_drawing_color_class_init (GalaDrawingColorClass * klass,
                               gpointer klass_data)
{
#line 13 "../lib/Drawing/Color.vala"
	gala_drawing_color_parent_class = g_type_class_peek_parent (klass);
#line 13 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drawing_color_finalize;
#line 1573 "Color.c"
}

static void
gala_drawing_color_instance_init (GalaDrawingColor * self,
                                  gpointer klass)
{
}

static void
gala_drawing_color_finalize (GObject * obj)
{
	GalaDrawingColor * self;
#line 13 "../lib/Drawing/Color.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_DRAWING_TYPE_COLOR, GalaDrawingColor);
#line 13 "../lib/Drawing/Color.vala"
	G_OBJECT_CLASS (gala_drawing_color_parent_class)->finalize (obj);
#line 1590 "Color.c"
}

/**
    * A class containing an RGBA color and methods for more powerful color manipulation.
    */
 G_GNUC_NO_INLINE static GType
gala_drawing_color_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDrawingColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drawing_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDrawingColor), 0, (GInstanceInitFunc) gala_drawing_color_instance_init, NULL };
	GType gala_drawing_color_type_id;
	gala_drawing_color_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaDrawingColor", &g_define_type_info, 0);
	return gala_drawing_color_type_id;
}

GType
gala_drawing_color_get_type (void)
{
	static gsize gala_drawing_color_type_id__once = 0;
	if (g_once_init_enter (&gala_drawing_color_type_id__once)) {
		GType gala_drawing_color_type_id;
		gala_drawing_color_type_id = gala_drawing_color_get_type_once ();
		g_once_init_leave (&gala_drawing_color_type_id__once, gala_drawing_color_type_id);
	}
	return gala_drawing_color_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

