/* Image.c generated by valac 0.56.18, the Vala compiler
 * generated from Image.vala, do not modify */

/*
 * Copyright 2015 Corentin Noël
 * Copyright 2025 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cogl/cogl.h>
#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_IMAGE_0_PROPERTY,
	GALA_IMAGE_NUM_PROPERTIES
};
static GParamSpec* gala_image_properties[GALA_IMAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _clutter_paint_node_unref0(var) ((var == NULL) ? NULL : (var = (clutter_paint_node_unref (var), NULL)))

struct _GalaImagePrivate {
	GdkPixbuf* pixbuf;
	CoglTexture* texture;
	guint width;
	guint height;
};

static gint GalaImage_private_offset;
static gpointer gala_image_parent_class = NULL;
static ClutterContentInterface * gala_image_clutter_content_parent_iface = NULL;

static gboolean gala_image_real_get_preferred_size (ClutterContent* base,
                                             gfloat* width,
                                             gfloat* height);
static void gala_image_real_paint_content (ClutterContent* base,
                                    ClutterActor* actor,
                                    ClutterPaintNode* node,
                                    ClutterPaintContext* paint_context);
static void gala_image_real_invalidate (ClutterContent* base);
static void gala_image_real_invalidate_size (ClutterContent* base);
static void gala_image_finalize (GObject * obj);
static GType gala_image_get_type_once (void);

static inline gpointer
gala_image_get_instance_private (GalaImage* self)
{
	return G_STRUCT_MEMBER_P (self, GalaImage_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../lib/Image.vala"
	return self ? g_object_ref (self) : NULL;
#line 74 "Image.c"
}

GalaImage*
gala_image_construct_from_pixbuf (GType object_type,
                                  GdkPixbuf* pixbuf)
{
	GalaImage * self = NULL;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 25 "../lib/Image.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 25 "../lib/Image.vala"
	self = (GalaImage*) g_object_new (object_type, NULL);
#line 26 "../lib/Image.vala"
	_tmp0_ = _g_object_ref0 (pixbuf);
#line 26 "../lib/Image.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 26 "../lib/Image.vala"
	self->priv->pixbuf = _tmp0_;
#line 27 "../lib/Image.vala"
	_tmp1_ = gdk_pixbuf_get_width (pixbuf);
#line 27 "../lib/Image.vala"
	_tmp2_ = _tmp1_;
#line 27 "../lib/Image.vala"
	self->priv->width = (guint) _tmp2_;
#line 28 "../lib/Image.vala"
	_tmp3_ = gdk_pixbuf_get_height (pixbuf);
#line 28 "../lib/Image.vala"
	_tmp4_ = _tmp3_;
#line 28 "../lib/Image.vala"
	self->priv->height = (guint) _tmp4_;
#line 29 "../lib/Image.vala"
	clutter_content_invalidate ((ClutterContent*) self);
#line 25 "../lib/Image.vala"
	return self;
#line 113 "Image.c"
}

GalaImage*
gala_image_new_from_pixbuf (GdkPixbuf* pixbuf)
{
#line 25 "../lib/Image.vala"
	return gala_image_construct_from_pixbuf (GALA_TYPE_IMAGE, pixbuf);
#line 121 "Image.c"
}

static gboolean
gala_image_real_get_preferred_size (ClutterContent* base,
                                    gfloat* width,
                                    gfloat* height)
{
	GalaImage * self;
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	CoglTexture* _tmp0_;
	CoglTexture* _tmp1_;
	CoglTexture* _tmp2_;
	gboolean result;
#line 32 "../lib/Image.vala"
	self = (GalaImage*) base;
#line 33 "../lib/Image.vala"
	_tmp0_ = self->priv->texture;
#line 33 "../lib/Image.vala"
	if (_tmp0_ == NULL) {
#line 34 "../lib/Image.vala"
		_vala_width = (gfloat) 0;
#line 35 "../lib/Image.vala"
		_vala_height = (gfloat) 0;
#line 36 "../lib/Image.vala"
		result = FALSE;
#line 36 "../lib/Image.vala"
		if (width) {
#line 36 "../lib/Image.vala"
			*width = _vala_width;
#line 152 "Image.c"
		}
#line 36 "../lib/Image.vala"
		if (height) {
#line 36 "../lib/Image.vala"
			*height = _vala_height;
#line 158 "Image.c"
		}
#line 36 "../lib/Image.vala"
		return result;
#line 162 "Image.c"
	}
#line 39 "../lib/Image.vala"
	_tmp1_ = self->priv->texture;
#line 39 "../lib/Image.vala"
	_vala_width = (gfloat) cogl_texture_get_width (_tmp1_);
#line 40 "../lib/Image.vala"
	_tmp2_ = self->priv->texture;
#line 40 "../lib/Image.vala"
	_vala_height = (gfloat) cogl_texture_get_height (_tmp2_);
#line 41 "../lib/Image.vala"
	result = TRUE;
#line 41 "../lib/Image.vala"
	if (width) {
#line 41 "../lib/Image.vala"
		*width = _vala_width;
#line 178 "Image.c"
	}
#line 41 "../lib/Image.vala"
	if (height) {
#line 41 "../lib/Image.vala"
		*height = _vala_height;
#line 184 "Image.c"
	}
#line 41 "../lib/Image.vala"
	return result;
#line 188 "Image.c"
}

static void
gala_image_real_paint_content (ClutterContent* base,
                               ClutterActor* actor,
                               ClutterPaintNode* node,
                               ClutterPaintContext* paint_context)
{
	GalaImage * self;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp1_;
	CoglTexture* _tmp32_;
	ClutterPaintNode* content_node = NULL;
	CoglTexture* _tmp33_;
	ClutterPaintNode* _tmp34_;
	ClutterPaintNode* _tmp35_;
	ClutterPaintNode* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 44 "../lib/Image.vala"
	self = (GalaImage*) base;
#line 44 "../lib/Image.vala"
	g_return_if_fail (actor != NULL);
#line 44 "../lib/Image.vala"
	g_return_if_fail (node != NULL);
#line 44 "../lib/Image.vala"
	g_return_if_fail (paint_context != NULL);
#line 45 "../lib/Image.vala"
	_tmp1_ = self->priv->pixbuf;
#line 45 "../lib/Image.vala"
	if (_tmp1_ != NULL) {
#line 219 "Image.c"
		CoglTexture* _tmp2_;
#line 45 "../lib/Image.vala"
		_tmp2_ = self->priv->texture;
#line 45 "../lib/Image.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 225 "Image.c"
	} else {
#line 45 "../lib/Image.vala"
		_tmp0_ = FALSE;
#line 229 "Image.c"
	}
#line 45 "../lib/Image.vala"
	if (_tmp0_) {
#line 233 "Image.c"
		CoglContext* cogl_context = NULL;
		ClutterContext* _tmp3_;
		ClutterContext* _tmp4_;
		ClutterBackend* _tmp5_;
		CoglContext* _tmp6_;
		CoglContext* _tmp7_;
		CoglPixelFormat _tmp8_ = 0;
		GdkPixbuf* _tmp9_;
		CoglPixelFormat pixel_format = 0;
#line 46 "../lib/Image.vala"
		_tmp3_ = clutter_actor_get_context (actor);
#line 46 "../lib/Image.vala"
		_tmp4_ = _tmp3_;
#line 46 "../lib/Image.vala"
		_tmp5_ = clutter_context_get_backend (_tmp4_);
#line 46 "../lib/Image.vala"
		_tmp6_ = clutter_backend_get_cogl_context (_tmp5_);
#line 46 "../lib/Image.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 46 "../lib/Image.vala"
		cogl_context = _tmp7_;
#line 47 "../lib/Image.vala"
		_tmp9_ = self->priv->pixbuf;
#line 47 "../lib/Image.vala"
		if (gdk_pixbuf_get_has_alpha (_tmp9_)) {
#line 47 "../lib/Image.vala"
			_tmp8_ = COGL_PIXEL_FORMAT_RGBA_8888;
#line 261 "Image.c"
		} else {
#line 47 "../lib/Image.vala"
			_tmp8_ = COGL_PIXEL_FORMAT_RGB_888;
#line 265 "Image.c"
		}
#line 47 "../lib/Image.vala"
		pixel_format = _tmp8_;
#line 269 "Image.c"
		{
			CoglTexture2D* _tmp10_ = NULL;
			CoglContext* _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			GdkPixbuf* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			GdkPixbuf* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			GdkPixbuf* _tmp21_;
			guint8* _tmp22_;
			CoglTexture2D* _tmp23_;
			CoglTexture2D* _tmp24_;
			gboolean _tmp25_ = FALSE;
			CoglTexture* _tmp26_;
#line 49 "../lib/Image.vala"
			_tmp11_ = cogl_context;
#line 49 "../lib/Image.vala"
			_tmp12_ = self->priv->pixbuf;
#line 49 "../lib/Image.vala"
			_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 49 "../lib/Image.vala"
			_tmp14_ = _tmp13_;
#line 49 "../lib/Image.vala"
			_tmp15_ = self->priv->pixbuf;
#line 49 "../lib/Image.vala"
			_tmp16_ = gdk_pixbuf_get_height (_tmp15_);
#line 49 "../lib/Image.vala"
			_tmp17_ = _tmp16_;
#line 49 "../lib/Image.vala"
			_tmp18_ = self->priv->pixbuf;
#line 49 "../lib/Image.vala"
			_tmp19_ = gdk_pixbuf_get_rowstride (_tmp18_);
#line 49 "../lib/Image.vala"
			_tmp20_ = _tmp19_;
#line 49 "../lib/Image.vala"
			_tmp21_ = self->priv->pixbuf;
#line 49 "../lib/Image.vala"
			_tmp22_ = gdk_pixbuf_get_pixels (_tmp21_);
#line 49 "../lib/Image.vala"
			_tmp23_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (_tmp11_, _tmp14_, _tmp17_, pixel_format, _tmp20_, _tmp22_, &_inner_error0_);
#line 49 "../lib/Image.vala"
			_tmp10_ = _tmp23_;
#line 49 "../lib/Image.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "Image.c"
				goto __catch0_g_error;
			}
#line 49 "../lib/Image.vala"
			_tmp24_ = _tmp10_;
#line 49 "../lib/Image.vala"
			_tmp10_ = NULL;
#line 49 "../lib/Image.vala"
			_g_object_unref0 (self->priv->texture);
#line 49 "../lib/Image.vala"
			self->priv->texture = (CoglTexture*) _tmp24_;
#line 50 "../lib/Image.vala"
			_tmp26_ = self->priv->texture;
#line 50 "../lib/Image.vala"
			if (self->priv->width != cogl_texture_get_width (_tmp26_)) {
#line 50 "../lib/Image.vala"
				_tmp25_ = TRUE;
#line 335 "Image.c"
			} else {
				CoglTexture* _tmp27_;
#line 50 "../lib/Image.vala"
				_tmp27_ = self->priv->texture;
#line 50 "../lib/Image.vala"
				_tmp25_ = self->priv->height != cogl_texture_get_height (_tmp27_);
#line 342 "Image.c"
			}
#line 50 "../lib/Image.vala"
			if (_tmp25_) {
#line 346 "Image.c"
				CoglTexture* _tmp28_;
				CoglTexture* _tmp29_;
#line 51 "../lib/Image.vala"
				_tmp28_ = self->priv->texture;
#line 51 "../lib/Image.vala"
				self->priv->width = cogl_texture_get_width (_tmp28_);
#line 52 "../lib/Image.vala"
				_tmp29_ = self->priv->texture;
#line 52 "../lib/Image.vala"
				self->priv->height = cogl_texture_get_height (_tmp29_);
#line 53 "../lib/Image.vala"
				clutter_content_invalidate_size ((ClutterContent*) self);
#line 359 "Image.c"
			}
#line 48 "../lib/Image.vala"
			_g_object_unref0 (_tmp10_);
#line 363 "Image.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_;
			const gchar* _tmp31_;
#line 48 "../lib/Image.vala"
			e = _inner_error0_;
#line 48 "../lib/Image.vala"
			_inner_error0_ = NULL;
#line 56 "../lib/Image.vala"
			_tmp30_ = e;
#line 56 "../lib/Image.vala"
			_tmp31_ = _tmp30_->message;
#line 56 "../lib/Image.vala"
			g_critical ("Image.vala:56: %s", _tmp31_);
#line 48 "../lib/Image.vala"
			_g_error_free0 (e);
#line 383 "Image.c"
		}
		__finally0:
#line 48 "../lib/Image.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../lib/Image.vala"
			_g_object_unref0 (cogl_context);
#line 48 "../lib/Image.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../lib/Image.vala"
			g_clear_error (&_inner_error0_);
#line 48 "../lib/Image.vala"
			return;
#line 396 "Image.c"
		}
#line 45 "../lib/Image.vala"
		_g_object_unref0 (cogl_context);
#line 400 "Image.c"
	}
#line 60 "../lib/Image.vala"
	_tmp32_ = self->priv->texture;
#line 60 "../lib/Image.vala"
	if (_tmp32_ == NULL) {
#line 61 "../lib/Image.vala"
		return;
#line 408 "Image.c"
	}
#line 63 "../lib/Image.vala"
	_tmp33_ = self->priv->texture;
#line 63 "../lib/Image.vala"
	_tmp34_ = clutter_actor_create_texture_paint_node (actor, _tmp33_);
#line 63 "../lib/Image.vala"
	content_node = _tmp34_;
#line 64 "../lib/Image.vala"
	_tmp35_ = content_node;
#line 64 "../lib/Image.vala"
	clutter_paint_node_set_static_name (_tmp35_, "Image Content");
#line 65 "../lib/Image.vala"
	_tmp36_ = content_node;
#line 65 "../lib/Image.vala"
	clutter_paint_node_add_child (node, _tmp36_);
#line 44 "../lib/Image.vala"
	_clutter_paint_node_unref0 (content_node);
#line 426 "Image.c"
}

static void
gala_image_real_invalidate (ClutterContent* base)
{
	GalaImage * self;
#line 68 "../lib/Image.vala"
	self = (GalaImage*) base;
#line 69 "../lib/Image.vala"
	_g_object_unref0 (self->priv->texture);
#line 69 "../lib/Image.vala"
	self->priv->texture = NULL;
#line 439 "Image.c"
}

static void
gala_image_real_invalidate_size (ClutterContent* base)
{
	GalaImage * self;
#line 72 "../lib/Image.vala"
	self = (GalaImage*) base;
#line 448 "Image.c"
}

GalaImage*
gala_image_construct (GType object_type)
{
	GalaImage * self = NULL;
#line 19 "../lib/Image.vala"
	self = (GalaImage*) g_object_new (object_type, NULL);
#line 19 "../lib/Image.vala"
	return self;
#line 459 "Image.c"
}

GalaImage*
gala_image_new (void)
{
#line 19 "../lib/Image.vala"
	return gala_image_construct (GALA_TYPE_IMAGE);
#line 467 "Image.c"
}

static void
gala_image_class_init (GalaImageClass * klass,
                       gpointer klass_data)
{
#line 19 "../lib/Image.vala"
	gala_image_parent_class = g_type_class_peek_parent (klass);
#line 19 "../lib/Image.vala"
	g_type_class_adjust_private_offset (klass, &GalaImage_private_offset);
#line 19 "../lib/Image.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_image_finalize;
#line 480 "Image.c"
}

static void
gala_image_clutter_content_interface_init (ClutterContentInterface * iface,
                                           gpointer iface_data)
{
#line 19 "../lib/Image.vala"
	gala_image_clutter_content_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../lib/Image.vala"
	iface->get_preferred_size = (gboolean (*) (ClutterContent*, gfloat*, gfloat*)) gala_image_real_get_preferred_size;
#line 19 "../lib/Image.vala"
	iface->paint_content = (void (*) (ClutterContent*, ClutterActor*, ClutterPaintNode*, ClutterPaintContext*)) gala_image_real_paint_content;
#line 19 "../lib/Image.vala"
	iface->invalidate = (void (*) (ClutterContent*)) gala_image_real_invalidate;
#line 19 "../lib/Image.vala"
	iface->invalidate_size = (void (*) (ClutterContent*)) gala_image_real_invalidate_size;
#line 497 "Image.c"
}

static void
gala_image_instance_init (GalaImage * self,
                          gpointer klass)
{
#line 19 "../lib/Image.vala"
	self->priv = gala_image_get_instance_private (self);
#line 506 "Image.c"
}

static void
gala_image_finalize (GObject * obj)
{
	GalaImage * self;
#line 19 "../lib/Image.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_IMAGE, GalaImage);
#line 20 "../lib/Image.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 21 "../lib/Image.vala"
	_g_object_unref0 (self->priv->texture);
#line 19 "../lib/Image.vala"
	G_OBJECT_CLASS (gala_image_parent_class)->finalize (obj);
#line 521 "Image.c"
}

 G_GNUC_NO_INLINE static GType
gala_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaImage), 0, (GInstanceInitFunc) gala_image_instance_init, NULL };
	static const GInterfaceInfo clutter_content_info = { (GInterfaceInitFunc) gala_image_clutter_content_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_image_type_id;
	gala_image_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaImage", &g_define_type_info, 0);
	g_type_add_interface_static (gala_image_type_id, clutter_content_get_type (), &clutter_content_info);
	GalaImage_private_offset = g_type_add_instance_private (gala_image_type_id, sizeof (GalaImagePrivate));
	return gala_image_type_id;
}

GType
gala_image_get_type (void)
{
	static gsize gala_image_type_id__once = 0;
	if (g_once_init_enter (&gala_image_type_id__once)) {
		GType gala_image_type_id;
		gala_image_type_id = gala_image_get_type_once ();
		g_once_init_leave (&gala_image_type_id__once, gala_image_type_id);
	}
	return gala_image_type_id__once;
}

