/* SpringTimeline.c generated by valac 0.56.18, the Vala compiler
 * generated from SpringTimeline.vala, do not modify */

/*
 * Copyright 2025 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define GALA_SPRING_TIMELINE_DELTA 0.001
#define GALA_SPRING_TIMELINE_MAX_ITERATIONS 20000
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_SPRING_TIMELINE (gala_spring_timeline_get_type ())
#define GALA_SPRING_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SPRING_TIMELINE, GalaSpringTimeline))
#define GALA_SPRING_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SPRING_TIMELINE, GalaSpringTimelineClass))
#define GALA_IS_SPRING_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SPRING_TIMELINE))
#define GALA_IS_SPRING_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SPRING_TIMELINE))
#define GALA_SPRING_TIMELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SPRING_TIMELINE, GalaSpringTimelineClass))

typedef struct _GalaSpringTimeline GalaSpringTimeline;
typedef struct _GalaSpringTimelineClass GalaSpringTimelineClass;
typedef struct _GalaSpringTimelinePrivate GalaSpringTimelinePrivate;
enum  {
	GALA_SPRING_TIMELINE_0_PROPERTY,
	GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY,
	GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY,
	GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY,
	GALA_SPRING_TIMELINE_DAMPING_PROPERTY,
	GALA_SPRING_TIMELINE_MASS_PROPERTY,
	GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY,
	GALA_SPRING_TIMELINE_EPSILON_PROPERTY,
	GALA_SPRING_TIMELINE_CLAMP_PROPERTY,
	GALA_SPRING_TIMELINE_NUM_PROPERTIES
};
static GParamSpec* gala_spring_timeline_properties[GALA_SPRING_TIMELINE_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
enum  {
	GALA_SPRING_TIMELINE_PROGRESS_SIGNAL,
	GALA_SPRING_TIMELINE_NUM_SIGNALS
};
static guint gala_spring_timeline_signals[GALA_SPRING_TIMELINE_NUM_SIGNALS] = {0};

struct _GalaSpringTimeline {
	ClutterTimeline parent_instance;
	GalaSpringTimelinePrivate * priv;
};

struct _GalaSpringTimelineClass {
	ClutterTimelineClass parent_class;
};

struct _GalaSpringTimelinePrivate {
	gdouble _value_from;
	gdouble _value_to;
	gdouble _initial_velocity;
	gdouble _damping;
	gdouble _mass;
	gdouble _stiffness;
	gdouble _epsilon;
	gboolean _clamp;
};

static gint GalaSpringTimeline_private_offset;
static gpointer gala_spring_timeline_parent_class = NULL;

VALA_EXTERN GType gala_spring_timeline_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSpringTimeline, g_object_unref)
VALA_EXTERN GalaSpringTimeline* gala_spring_timeline_new (ClutterActor* actor,
                                              gdouble value_from,
                                              gdouble value_to,
                                              gdouble initial_velocity,
                                              gdouble damping_ratio,
                                              gdouble mass,
                                              gdouble stiffness);
VALA_EXTERN GalaSpringTimeline* gala_spring_timeline_construct (GType object_type,
                                                    ClutterActor* actor,
                                                    gdouble value_from,
                                                    gdouble value_to,
                                                    gdouble initial_velocity,
                                                    gdouble damping_ratio,
                                                    gdouble mass,
                                                    gdouble stiffness);
static guint gala_spring_timeline_calculate_duration (GalaSpringTimeline* self);
static gboolean gala_spring_timeline_approx (GalaSpringTimeline* self,
                                      gdouble a,
                                      gdouble b,
                                      gdouble epsilon);
static gdouble gala_spring_timeline_oscillate (GalaSpringTimeline* self,
                                        guint time,
                                        gdouble** velocity);
VALA_EXTERN gdouble gala_spring_timeline_get_damping (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_mass (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_stiffness (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_initial_velocity (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_value_from (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_value_to (GalaSpringTimeline* self);
static gdouble* _double_dup (gdouble* self);
static guint gala_spring_timeline_get_first_zero (GalaSpringTimeline* self);
VALA_EXTERN gdouble gala_spring_timeline_get_epsilon (GalaSpringTimeline* self);
VALA_EXTERN gboolean gala_spring_timeline_get_clamp (GalaSpringTimeline* self);
static void gala_spring_timeline_real_new_frame (ClutterTimeline* base,
                                          gint time);
static void gala_spring_timeline_real_stopped (ClutterTimeline* base,
                                        gboolean is_finished);
static void gala_spring_timeline_set_value_from (GalaSpringTimeline* self,
                                          gdouble value);
static void gala_spring_timeline_set_value_to (GalaSpringTimeline* self,
                                        gdouble value);
static void gala_spring_timeline_set_initial_velocity (GalaSpringTimeline* self,
                                                gdouble value);
static void gala_spring_timeline_set_damping (GalaSpringTimeline* self,
                                       gdouble value);
static void gala_spring_timeline_set_mass (GalaSpringTimeline* self,
                                    gdouble value);
static void gala_spring_timeline_set_stiffness (GalaSpringTimeline* self,
                                         gdouble value);
static void gala_spring_timeline_set_epsilon (GalaSpringTimeline* self,
                                       gdouble value);
static void gala_spring_timeline_set_clamp (GalaSpringTimeline* self,
                                     gboolean value);
static void gala_spring_timeline_finalize (GObject * obj);
static GType gala_spring_timeline_get_type_once (void);
static void _vala_gala_spring_timeline_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_spring_timeline_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_spring_timeline_get_instance_private (GalaSpringTimeline* self)
{
	return G_STRUCT_MEMBER_P (self, GalaSpringTimeline_private_offset);
}

GalaSpringTimeline*
gala_spring_timeline_construct (GType object_type,
                                ClutterActor* actor,
                                gdouble value_from,
                                gdouble value_to,
                                gdouble initial_velocity,
                                gdouble damping_ratio,
                                gdouble mass,
                                gdouble stiffness)
{
	GalaSpringTimeline * self = NULL;
	gdouble critical_damping = 0.0;
#line 32 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 33 "../src/Gestures/SpringTimeline.vala"
	critical_damping = 2 * sqrt (mass * stiffness);
#line 35 "../src/Gestures/SpringTimeline.vala"
	self = (GalaSpringTimeline*) g_object_new (object_type, "actor", actor, "value-from", value_from, "value-to", value_to, "initial-velocity", initial_velocity, "damping", critical_damping * damping_ratio, "mass", mass, "stiffness", stiffness, NULL);
#line 45 "../src/Gestures/SpringTimeline.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) self, gala_spring_timeline_calculate_duration (self));
#line 47 "../src/Gestures/SpringTimeline.vala"
	clutter_timeline_start ((ClutterTimeline*) self);
#line 32 "../src/Gestures/SpringTimeline.vala"
	return self;
#line 188 "SpringTimeline.c"
}

GalaSpringTimeline*
gala_spring_timeline_new (ClutterActor* actor,
                          gdouble value_from,
                          gdouble value_to,
                          gdouble initial_velocity,
                          gdouble damping_ratio,
                          gdouble mass,
                          gdouble stiffness)
{
#line 32 "../src/Gestures/SpringTimeline.vala"
	return gala_spring_timeline_construct (GALA_TYPE_SPRING_TIMELINE, actor, value_from, value_to, initial_velocity, damping_ratio, mass, stiffness);
#line 202 "SpringTimeline.c"
}

static gboolean
gala_spring_timeline_approx (GalaSpringTimeline* self,
                             gdouble a,
                             gdouble b,
                             gdouble epsilon)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 50 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/Gestures/SpringTimeline.vala"
	if (fabs (a - b) < epsilon) {
#line 51 "../src/Gestures/SpringTimeline.vala"
		_tmp0_ = TRUE;
#line 219 "SpringTimeline.c"
	} else {
#line 51 "../src/Gestures/SpringTimeline.vala"
		_tmp0_ = a == b;
#line 223 "SpringTimeline.c"
	}
#line 51 "../src/Gestures/SpringTimeline.vala"
	result = _tmp0_;
#line 51 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 229 "SpringTimeline.c"
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 78 "../src/Gestures/SpringTimeline.vala"
	dup = g_new0 (gdouble, 1);
#line 78 "../src/Gestures/SpringTimeline.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 78 "../src/Gestures/SpringTimeline.vala"
	return dup;
#line 242 "SpringTimeline.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 78 "../src/Gestures/SpringTimeline.vala"
	return self ? _double_dup (self) : NULL;
#line 250 "SpringTimeline.c"
}

static gdouble
gala_spring_timeline_oscillate (GalaSpringTimeline* self,
                                guint time,
                                gdouble** velocity)
{
	gdouble* _vala_velocity = NULL;
	gdouble b = 0.0;
	gdouble _tmp0_;
	gdouble m = 0.0;
	gdouble _tmp1_;
	gdouble k = 0.0;
	gdouble _tmp2_;
	gdouble v0 = 0.0;
	gdouble _tmp3_;
	gdouble t = 0.0;
	gdouble beta = 0.0;
	gdouble omega0 = 0.0;
	gdouble x0 = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble envelope = 0.0;
	gdouble result;
#line 54 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 55 "../src/Gestures/SpringTimeline.vala"
	_tmp0_ = self->priv->_damping;
#line 55 "../src/Gestures/SpringTimeline.vala"
	b = _tmp0_;
#line 56 "../src/Gestures/SpringTimeline.vala"
	_tmp1_ = self->priv->_mass;
#line 56 "../src/Gestures/SpringTimeline.vala"
	m = _tmp1_;
#line 57 "../src/Gestures/SpringTimeline.vala"
	_tmp2_ = self->priv->_stiffness;
#line 57 "../src/Gestures/SpringTimeline.vala"
	k = _tmp2_;
#line 58 "../src/Gestures/SpringTimeline.vala"
	_tmp3_ = self->priv->_initial_velocity;
#line 58 "../src/Gestures/SpringTimeline.vala"
	v0 = _tmp3_;
#line 60 "../src/Gestures/SpringTimeline.vala"
	t = time / 1000.0;
#line 62 "../src/Gestures/SpringTimeline.vala"
	beta = b / (2 * m);
#line 63 "../src/Gestures/SpringTimeline.vala"
	omega0 = sqrt (k / m);
#line 65 "../src/Gestures/SpringTimeline.vala"
	_tmp4_ = self->priv->_value_from;
#line 65 "../src/Gestures/SpringTimeline.vala"
	_tmp5_ = self->priv->_value_to;
#line 65 "../src/Gestures/SpringTimeline.vala"
	x0 = _tmp4_ - _tmp5_;
#line 67 "../src/Gestures/SpringTimeline.vala"
	envelope = exp ((-beta) * t);
#line 77 "../src/Gestures/SpringTimeline.vala"
	if (gala_spring_timeline_approx (self, beta, omega0, (gdouble) FLT_EPSILON)) {
#line 309 "SpringTimeline.c"
		gdouble _tmp6_;
		gdouble* _tmp7_;
		gdouble _tmp8_;
#line 78 "../src/Gestures/SpringTimeline.vala"
		_tmp6_ = envelope * (((((-beta) * t) * v0) - (((beta * beta) * t) * x0)) + v0);
#line 78 "../src/Gestures/SpringTimeline.vala"
		_tmp7_ = __double_dup0 (&_tmp6_);
#line 78 "../src/Gestures/SpringTimeline.vala"
		_g_free0 (_vala_velocity);
#line 78 "../src/Gestures/SpringTimeline.vala"
		_vala_velocity = _tmp7_;
#line 80 "../src/Gestures/SpringTimeline.vala"
		_tmp8_ = self->priv->_value_to;
#line 80 "../src/Gestures/SpringTimeline.vala"
		result = _tmp8_ + (envelope * (x0 + (((beta * x0) + v0) * t)));
#line 80 "../src/Gestures/SpringTimeline.vala"
		if (velocity) {
#line 80 "../src/Gestures/SpringTimeline.vala"
			*velocity = _vala_velocity;
#line 329 "SpringTimeline.c"
		} else {
#line 80 "../src/Gestures/SpringTimeline.vala"
			_g_free0 (_vala_velocity);
#line 333 "SpringTimeline.c"
		}
#line 80 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 337 "SpringTimeline.c"
	}
#line 84 "../src/Gestures/SpringTimeline.vala"
	if (beta < omega0) {
#line 341 "SpringTimeline.c"
		gdouble omega1 = 0.0;
		gdouble _tmp9_;
		gdouble* _tmp10_;
		gdouble _tmp11_;
#line 85 "../src/Gestures/SpringTimeline.vala"
		omega1 = sqrt ((omega0 * omega0) - (beta * beta));
#line 87 "../src/Gestures/SpringTimeline.vala"
		_tmp9_ = envelope * ((v0 * cos (omega1 * t)) - (((x0 * omega1) + ((((beta * beta) * x0) + (beta * v0)) / omega1)) * sin (omega1 * t)));
#line 87 "../src/Gestures/SpringTimeline.vala"
		_tmp10_ = __double_dup0 (&_tmp9_);
#line 87 "../src/Gestures/SpringTimeline.vala"
		_g_free0 (_vala_velocity);
#line 87 "../src/Gestures/SpringTimeline.vala"
		_vala_velocity = _tmp10_;
#line 89 "../src/Gestures/SpringTimeline.vala"
		_tmp11_ = self->priv->_value_to;
#line 89 "../src/Gestures/SpringTimeline.vala"
		result = _tmp11_ + (envelope * ((x0 * cos (omega1 * t)) + ((((beta * x0) + v0) / omega1) * sin (omega1 * t))));
#line 89 "../src/Gestures/SpringTimeline.vala"
		if (velocity) {
#line 89 "../src/Gestures/SpringTimeline.vala"
			*velocity = _vala_velocity;
#line 364 "SpringTimeline.c"
		} else {
#line 89 "../src/Gestures/SpringTimeline.vala"
			_g_free0 (_vala_velocity);
#line 368 "SpringTimeline.c"
		}
#line 89 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 372 "SpringTimeline.c"
	}
#line 93 "../src/Gestures/SpringTimeline.vala"
	if (beta > omega0) {
#line 376 "SpringTimeline.c"
		gdouble omega2 = 0.0;
		gdouble _tmp12_;
		gdouble* _tmp13_;
		gdouble _tmp14_;
#line 94 "../src/Gestures/SpringTimeline.vala"
		omega2 = sqrt ((beta * beta) - (omega0 * omega0));
#line 96 "../src/Gestures/SpringTimeline.vala"
		_tmp12_ = envelope * ((v0 * cosh (omega2 * t)) + (((omega2 * x0) - ((((beta * beta) * x0) + (beta * v0)) / omega2)) * sinh (omega2 * t)));
#line 96 "../src/Gestures/SpringTimeline.vala"
		_tmp13_ = __double_dup0 (&_tmp12_);
#line 96 "../src/Gestures/SpringTimeline.vala"
		_g_free0 (_vala_velocity);
#line 96 "../src/Gestures/SpringTimeline.vala"
		_vala_velocity = _tmp13_;
#line 98 "../src/Gestures/SpringTimeline.vala"
		_tmp14_ = self->priv->_value_to;
#line 98 "../src/Gestures/SpringTimeline.vala"
		result = _tmp14_ + (envelope * ((x0 * cosh (omega2 * t)) + ((((beta * x0) + v0) / omega2) * sinh (omega2 * t))));
#line 98 "../src/Gestures/SpringTimeline.vala"
		if (velocity) {
#line 98 "../src/Gestures/SpringTimeline.vala"
			*velocity = _vala_velocity;
#line 399 "SpringTimeline.c"
		} else {
#line 98 "../src/Gestures/SpringTimeline.vala"
			_g_free0 (_vala_velocity);
#line 403 "SpringTimeline.c"
		}
#line 98 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 407 "SpringTimeline.c"
	}
#line 101 "../src/Gestures/SpringTimeline.vala"
	g_assert_not_reached ();
#line 411 "SpringTimeline.c"
}

static guint
gala_spring_timeline_get_first_zero (GalaSpringTimeline* self)
{
	guint i = 0U;
	gdouble y = 0.0;
	guint result;
#line 105 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 108 "../src/Gestures/SpringTimeline.vala"
	i = (guint) 1;
#line 109 "../src/Gestures/SpringTimeline.vala"
	y = gala_spring_timeline_oscillate (self, i, NULL);
#line 111 "../src/Gestures/SpringTimeline.vala"
	while (TRUE) {
#line 428 "SpringTimeline.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gdouble _tmp2_;
		gdouble _tmp3_;
		guint _tmp11_;
#line 111 "../src/Gestures/SpringTimeline.vala"
		_tmp2_ = self->priv->_value_to;
#line 111 "../src/Gestures/SpringTimeline.vala"
		_tmp3_ = self->priv->_value_from;
#line 111 "../src/Gestures/SpringTimeline.vala"
		if ((_tmp2_ - _tmp3_) > DBL_EPSILON) {
#line 440 "SpringTimeline.c"
			gdouble _tmp4_;
			gdouble _tmp5_;
#line 111 "../src/Gestures/SpringTimeline.vala"
			_tmp4_ = self->priv->_value_to;
#line 111 "../src/Gestures/SpringTimeline.vala"
			_tmp5_ = self->priv->_epsilon;
#line 111 "../src/Gestures/SpringTimeline.vala"
			_tmp1_ = (_tmp4_ - y) > _tmp5_;
#line 449 "SpringTimeline.c"
		} else {
#line 111 "../src/Gestures/SpringTimeline.vala"
			_tmp1_ = FALSE;
#line 453 "SpringTimeline.c"
		}
#line 111 "../src/Gestures/SpringTimeline.vala"
		if (_tmp1_) {
#line 111 "../src/Gestures/SpringTimeline.vala"
			_tmp0_ = TRUE;
#line 459 "SpringTimeline.c"
		} else {
			gboolean _tmp6_ = FALSE;
			gdouble _tmp7_;
			gdouble _tmp8_;
#line 112 "../src/Gestures/SpringTimeline.vala"
			_tmp7_ = self->priv->_value_from;
#line 112 "../src/Gestures/SpringTimeline.vala"
			_tmp8_ = self->priv->_value_to;
#line 112 "../src/Gestures/SpringTimeline.vala"
			if ((_tmp7_ - _tmp8_) > DBL_EPSILON) {
#line 470 "SpringTimeline.c"
				gdouble _tmp9_;
				gdouble _tmp10_;
#line 112 "../src/Gestures/SpringTimeline.vala"
				_tmp9_ = self->priv->_value_to;
#line 112 "../src/Gestures/SpringTimeline.vala"
				_tmp10_ = self->priv->_epsilon;
#line 112 "../src/Gestures/SpringTimeline.vala"
				_tmp6_ = (y - _tmp9_) > _tmp10_;
#line 479 "SpringTimeline.c"
			} else {
#line 112 "../src/Gestures/SpringTimeline.vala"
				_tmp6_ = FALSE;
#line 483 "SpringTimeline.c"
			}
#line 112 "../src/Gestures/SpringTimeline.vala"
			_tmp0_ = _tmp6_;
#line 487 "SpringTimeline.c"
		}
#line 111 "../src/Gestures/SpringTimeline.vala"
		if (!_tmp0_) {
#line 111 "../src/Gestures/SpringTimeline.vala"
			break;
#line 493 "SpringTimeline.c"
		}
#line 114 "../src/Gestures/SpringTimeline.vala"
		if (i > ((guint) GALA_SPRING_TIMELINE_MAX_ITERATIONS)) {
#line 115 "../src/Gestures/SpringTimeline.vala"
			result = (guint) 0;
#line 115 "../src/Gestures/SpringTimeline.vala"
			return result;
#line 501 "SpringTimeline.c"
		}
#line 118 "../src/Gestures/SpringTimeline.vala"
		i = i + 1;
#line 118 "../src/Gestures/SpringTimeline.vala"
		_tmp11_ = i;
#line 118 "../src/Gestures/SpringTimeline.vala"
		y = gala_spring_timeline_oscillate (self, _tmp11_, NULL);
#line 509 "SpringTimeline.c"
	}
#line 121 "../src/Gestures/SpringTimeline.vala"
	result = i;
#line 121 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 515 "SpringTimeline.c"
}

static guint
gala_spring_timeline_calculate_duration (GalaSpringTimeline* self)
{
	gdouble beta = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble omega0 = 0.0;
	gdouble x0 = 0.0;
	gdouble y0 = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble m = 0.0;
	gint i = 0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gboolean _tmp9_ = FALSE;
	gdouble _tmp10_;
	guint result;
#line 124 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 125 "../src/Gestures/SpringTimeline.vala"
	_tmp0_ = self->priv->_damping;
#line 125 "../src/Gestures/SpringTimeline.vala"
	_tmp1_ = self->priv->_mass;
#line 125 "../src/Gestures/SpringTimeline.vala"
	beta = _tmp0_ / (2 * _tmp1_);
#line 131 "../src/Gestures/SpringTimeline.vala"
	i = 0;
#line 133 "../src/Gestures/SpringTimeline.vala"
	if (gala_spring_timeline_approx (self, beta, (gdouble) 0, DBL_EPSILON)) {
#line 133 "../src/Gestures/SpringTimeline.vala"
		_tmp2_ = TRUE;
#line 553 "SpringTimeline.c"
	} else {
#line 133 "../src/Gestures/SpringTimeline.vala"
		_tmp2_ = beta < ((gdouble) 0);
#line 557 "SpringTimeline.c"
	}
#line 133 "../src/Gestures/SpringTimeline.vala"
	if (_tmp2_) {
#line 134 "../src/Gestures/SpringTimeline.vala"
		result = (guint) -1;
#line 134 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 565 "SpringTimeline.c"
	}
#line 137 "../src/Gestures/SpringTimeline.vala"
	_tmp3_ = self->priv->_clamp;
#line 137 "../src/Gestures/SpringTimeline.vala"
	if (_tmp3_) {
#line 571 "SpringTimeline.c"
		gdouble _tmp4_;
		gdouble _tmp5_;
#line 138 "../src/Gestures/SpringTimeline.vala"
		_tmp4_ = self->priv->_value_to;
#line 138 "../src/Gestures/SpringTimeline.vala"
		_tmp5_ = self->priv->_value_from;
#line 138 "../src/Gestures/SpringTimeline.vala"
		if (gala_spring_timeline_approx (self, _tmp4_, _tmp5_, DBL_EPSILON)) {
#line 139 "../src/Gestures/SpringTimeline.vala"
			result = (guint) 0;
#line 139 "../src/Gestures/SpringTimeline.vala"
			return result;
#line 584 "SpringTimeline.c"
		}
#line 142 "../src/Gestures/SpringTimeline.vala"
		result = gala_spring_timeline_get_first_zero (self);
#line 142 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 590 "SpringTimeline.c"
	}
#line 145 "../src/Gestures/SpringTimeline.vala"
	_tmp6_ = self->priv->_stiffness;
#line 145 "../src/Gestures/SpringTimeline.vala"
	_tmp7_ = self->priv->_mass;
#line 145 "../src/Gestures/SpringTimeline.vala"
	omega0 = sqrt (_tmp6_ / _tmp7_);
#line 152 "../src/Gestures/SpringTimeline.vala"
	_tmp8_ = self->priv->_epsilon;
#line 152 "../src/Gestures/SpringTimeline.vala"
	x0 = (-log (_tmp8_)) / beta;
#line 156 "../src/Gestures/SpringTimeline.vala"
	if (gala_spring_timeline_approx (self, beta, omega0, (gdouble) FLT_EPSILON)) {
#line 156 "../src/Gestures/SpringTimeline.vala"
		_tmp9_ = TRUE;
#line 606 "SpringTimeline.c"
	} else {
#line 156 "../src/Gestures/SpringTimeline.vala"
		_tmp9_ = beta < omega0;
#line 610 "SpringTimeline.c"
	}
#line 156 "../src/Gestures/SpringTimeline.vala"
	if (_tmp9_) {
#line 157 "../src/Gestures/SpringTimeline.vala"
		result = (guint) (x0 * 1000);
#line 157 "../src/Gestures/SpringTimeline.vala"
		return result;
#line 618 "SpringTimeline.c"
	}
#line 166 "../src/Gestures/SpringTimeline.vala"
	y0 = gala_spring_timeline_oscillate (self, (guint) (x0 * 1000), NULL);
#line 167 "../src/Gestures/SpringTimeline.vala"
	m = (gala_spring_timeline_oscillate (self, (guint) ((x0 + GALA_SPRING_TIMELINE_DELTA) * 1000), NULL) - y0) / GALA_SPRING_TIMELINE_DELTA;
#line 169 "../src/Gestures/SpringTimeline.vala"
	_tmp10_ = self->priv->_value_to;
#line 169 "../src/Gestures/SpringTimeline.vala"
	x1 = ((_tmp10_ - y0) + (m * x0)) / m;
#line 170 "../src/Gestures/SpringTimeline.vala"
	y1 = gala_spring_timeline_oscillate (self, (guint) (x1 * 1000), NULL);
#line 172 "../src/Gestures/SpringTimeline.vala"
	while (TRUE) {
#line 632 "SpringTimeline.c"
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		gint _tmp14_;
#line 172 "../src/Gestures/SpringTimeline.vala"
		_tmp11_ = self->priv->_value_to;
#line 172 "../src/Gestures/SpringTimeline.vala"
		_tmp12_ = self->priv->_epsilon;
#line 172 "../src/Gestures/SpringTimeline.vala"
		if (!(fabs (_tmp11_ - y1) > _tmp12_)) {
#line 172 "../src/Gestures/SpringTimeline.vala"
			break;
#line 645 "SpringTimeline.c"
		}
#line 173 "../src/Gestures/SpringTimeline.vala"
		if (i > 1000) {
#line 174 "../src/Gestures/SpringTimeline.vala"
			result = (guint) 0;
#line 174 "../src/Gestures/SpringTimeline.vala"
			return result;
#line 653 "SpringTimeline.c"
		}
#line 177 "../src/Gestures/SpringTimeline.vala"
		x0 = x1;
#line 178 "../src/Gestures/SpringTimeline.vala"
		y0 = y1;
#line 180 "../src/Gestures/SpringTimeline.vala"
		m = (gala_spring_timeline_oscillate (self, (guint) ((x0 + GALA_SPRING_TIMELINE_DELTA) * 1000), NULL) - y0) / GALA_SPRING_TIMELINE_DELTA;
#line 182 "../src/Gestures/SpringTimeline.vala"
		_tmp13_ = self->priv->_value_to;
#line 182 "../src/Gestures/SpringTimeline.vala"
		x1 = ((_tmp13_ - y0) + (m * x0)) / m;
#line 183 "../src/Gestures/SpringTimeline.vala"
		y1 = gala_spring_timeline_oscillate (self, (guint) (x1 * 1000), NULL);
#line 184 "../src/Gestures/SpringTimeline.vala"
		_tmp14_ = i;
#line 184 "../src/Gestures/SpringTimeline.vala"
		i = _tmp14_ + 1;
#line 671 "SpringTimeline.c"
	}
#line 187 "../src/Gestures/SpringTimeline.vala"
	result = (guint) (x1 * 1000);
#line 187 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 677 "SpringTimeline.c"
}

static void
gala_spring_timeline_real_new_frame (ClutterTimeline* base,
                                     gint time)
{
	GalaSpringTimeline * self;
	gdouble velocity = 0.0;
	gdouble val = 0.0;
	gdouble* _tmp0_ = NULL;
	gdouble _tmp1_;
	gdouble* _tmp2_;
	gdouble _tmp3_;
#line 190 "../src/Gestures/SpringTimeline.vala"
	self = (GalaSpringTimeline*) base;
#line 192 "../src/Gestures/SpringTimeline.vala"
	_tmp1_ = gala_spring_timeline_oscillate (self, (guint) time, &_tmp0_);
#line 192 "../src/Gestures/SpringTimeline.vala"
	_tmp2_ = _tmp0_;
#line 192 "../src/Gestures/SpringTimeline.vala"
	velocity = *_tmp2_;
#line 192 "../src/Gestures/SpringTimeline.vala"
	_tmp3_ = _tmp1_;
#line 192 "../src/Gestures/SpringTimeline.vala"
	_g_free0 (_tmp2_);
#line 192 "../src/Gestures/SpringTimeline.vala"
	val = _tmp3_;
#line 194 "../src/Gestures/SpringTimeline.vala"
	g_signal_emit (self, gala_spring_timeline_signals[GALA_SPRING_TIMELINE_PROGRESS_SIGNAL], 0, val);
#line 707 "SpringTimeline.c"
}

static void
gala_spring_timeline_real_stopped (ClutterTimeline* base,
                                   gboolean is_finished)
{
	GalaSpringTimeline * self;
#line 197 "../src/Gestures/SpringTimeline.vala"
	self = (GalaSpringTimeline*) base;
#line 198 "../src/Gestures/SpringTimeline.vala"
	if (is_finished) {
#line 719 "SpringTimeline.c"
		gdouble _tmp0_;
#line 199 "../src/Gestures/SpringTimeline.vala"
		_tmp0_ = self->priv->_value_to;
#line 199 "../src/Gestures/SpringTimeline.vala"
		g_signal_emit (self, gala_spring_timeline_signals[GALA_SPRING_TIMELINE_PROGRESS_SIGNAL], 0, _tmp0_);
#line 725 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_value_from (GalaSpringTimeline* self)
{
	gdouble result;
#line 20 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 20 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_value_from;
#line 20 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 739 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_value_from (GalaSpringTimeline* self,
                                     gdouble value)
{
	gdouble old_value;
#line 20 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_value_from (self);
#line 20 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 20 "../src/Gestures/SpringTimeline.vala"
		self->priv->_value_from = value;
#line 20 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY]);
#line 757 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_value_to (GalaSpringTimeline* self)
{
	gdouble result;
#line 21 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 21 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_value_to;
#line 21 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 771 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_value_to (GalaSpringTimeline* self,
                                   gdouble value)
{
	gdouble old_value;
#line 21 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_value_to (self);
#line 21 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 21 "../src/Gestures/SpringTimeline.vala"
		self->priv->_value_to = value;
#line 21 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY]);
#line 789 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_initial_velocity (GalaSpringTimeline* self)
{
	gdouble result;
#line 22 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 22 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_initial_velocity;
#line 22 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 803 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_initial_velocity (GalaSpringTimeline* self,
                                           gdouble value)
{
	gdouble old_value;
#line 22 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_initial_velocity (self);
#line 22 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 22 "../src/Gestures/SpringTimeline.vala"
		self->priv->_initial_velocity = value;
#line 22 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY]);
#line 821 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_damping (GalaSpringTimeline* self)
{
	gdouble result;
#line 24 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 24 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_damping;
#line 24 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 835 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_damping (GalaSpringTimeline* self,
                                  gdouble value)
{
	gdouble old_value;
#line 24 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_damping (self);
#line 24 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 24 "../src/Gestures/SpringTimeline.vala"
		self->priv->_damping = value;
#line 24 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_DAMPING_PROPERTY]);
#line 853 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_mass (GalaSpringTimeline* self)
{
	gdouble result;
#line 25 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 25 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_mass;
#line 25 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 867 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_mass (GalaSpringTimeline* self,
                               gdouble value)
{
	gdouble old_value;
#line 25 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_mass (self);
#line 25 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 25 "../src/Gestures/SpringTimeline.vala"
		self->priv->_mass = value;
#line 25 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_MASS_PROPERTY]);
#line 885 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_stiffness (GalaSpringTimeline* self)
{
	gdouble result;
#line 26 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 26 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_stiffness;
#line 26 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 899 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_stiffness (GalaSpringTimeline* self,
                                    gdouble value)
{
	gdouble old_value;
#line 26 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_stiffness (self);
#line 26 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 26 "../src/Gestures/SpringTimeline.vala"
		self->priv->_stiffness = value;
#line 26 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY]);
#line 917 "SpringTimeline.c"
	}
}

gdouble
gala_spring_timeline_get_epsilon (GalaSpringTimeline* self)
{
	gdouble result;
#line 28 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 28 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_epsilon;
#line 28 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 931 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_epsilon (GalaSpringTimeline* self,
                                  gdouble value)
{
	gdouble old_value;
#line 28 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_epsilon (self);
#line 28 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 28 "../src/Gestures/SpringTimeline.vala"
		self->priv->_epsilon = value;
#line 28 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_EPSILON_PROPERTY]);
#line 949 "SpringTimeline.c"
	}
}

gboolean
gala_spring_timeline_get_clamp (GalaSpringTimeline* self)
{
	gboolean result;
#line 30 "../src/Gestures/SpringTimeline.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/Gestures/SpringTimeline.vala"
	result = self->priv->_clamp;
#line 30 "../src/Gestures/SpringTimeline.vala"
	return result;
#line 963 "SpringTimeline.c"
}

static void
gala_spring_timeline_set_clamp (GalaSpringTimeline* self,
                                gboolean value)
{
	gboolean old_value;
#line 30 "../src/Gestures/SpringTimeline.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Gestures/SpringTimeline.vala"
	old_value = gala_spring_timeline_get_clamp (self);
#line 30 "../src/Gestures/SpringTimeline.vala"
	if (old_value != value) {
#line 30 "../src/Gestures/SpringTimeline.vala"
		self->priv->_clamp = value;
#line 30 "../src/Gestures/SpringTimeline.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_CLAMP_PROPERTY]);
#line 981 "SpringTimeline.c"
	}
}

static void
gala_spring_timeline_class_init (GalaSpringTimelineClass * klass,
                                 gpointer klass_data)
{
#line 15 "../src/Gestures/SpringTimeline.vala"
	gala_spring_timeline_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_type_class_adjust_private_offset (klass, &GalaSpringTimeline_private_offset);
#line 15 "../src/Gestures/SpringTimeline.vala"
	((ClutterTimelineClass *) klass)->new_frame = (void (*) (ClutterTimeline*, gint)) gala_spring_timeline_real_new_frame;
#line 15 "../src/Gestures/SpringTimeline.vala"
	((ClutterTimelineClass *) klass)->stopped = (void (*) (ClutterTimeline*, gboolean)) gala_spring_timeline_real_stopped;
#line 15 "../src/Gestures/SpringTimeline.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_spring_timeline_get_property;
#line 15 "../src/Gestures/SpringTimeline.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_spring_timeline_set_property;
#line 15 "../src/Gestures/SpringTimeline.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_spring_timeline_finalize;
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY] = g_param_spec_double ("value-from", "value-from", "value-from", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY] = g_param_spec_double ("value-to", "value-to", "value-to", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY] = g_param_spec_double ("initial-velocity", "initial-velocity", "initial-velocity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_DAMPING_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_DAMPING_PROPERTY] = g_param_spec_double ("damping", "damping", "damping", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_MASS_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_MASS_PROPERTY] = g_param_spec_double ("mass", "mass", "mass", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY] = g_param_spec_double ("stiffness", "stiffness", "stiffness", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_EPSILON_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_EPSILON_PROPERTY] = g_param_spec_double ("epsilon", "epsilon", "epsilon", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0001, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SPRING_TIMELINE_CLAMP_PROPERTY, gala_spring_timeline_properties[GALA_SPRING_TIMELINE_CLAMP_PROPERTY] = g_param_spec_boolean ("clamp", "clamp", "clamp", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../src/Gestures/SpringTimeline.vala"
	gala_spring_timeline_signals[GALA_SPRING_TIMELINE_PROGRESS_SIGNAL] = g_signal_new ("progress", GALA_TYPE_SPRING_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 1021 "SpringTimeline.c"
}

static void
gala_spring_timeline_instance_init (GalaSpringTimeline * self,
                                    gpointer klass)
{
#line 15 "../src/Gestures/SpringTimeline.vala"
	self->priv = gala_spring_timeline_get_instance_private (self);
#line 28 "../src/Gestures/SpringTimeline.vala"
	self->priv->_epsilon = 0.0001;
#line 1032 "SpringTimeline.c"
}

static void
gala_spring_timeline_finalize (GObject * obj)
{
	GalaSpringTimeline * self;
#line 15 "../src/Gestures/SpringTimeline.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SPRING_TIMELINE, GalaSpringTimeline);
#line 15 "../src/Gestures/SpringTimeline.vala"
	G_OBJECT_CLASS (gala_spring_timeline_parent_class)->finalize (obj);
#line 1043 "SpringTimeline.c"
}

/**
 * Based on libadwaita's AdwSpringAnimation
 * [[https://gitlab.gnome.org/GNOME/libadwaita/-/blob/main/src/adw-spring-animation.c?ref_type=heads]]
 *
 * For documentation about the params refer to [[https://valadoc.org/libadwaita-1/Adw.SpringAnimation.html]]
 * and [[https://valadoc.org/libadwaita-1/Adw.SpringParams.html]].
 */
 G_GNUC_NO_INLINE static GType
gala_spring_timeline_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaSpringTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_spring_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaSpringTimeline), 0, (GInstanceInitFunc) gala_spring_timeline_instance_init, NULL };
	GType gala_spring_timeline_type_id;
	gala_spring_timeline_type_id = g_type_register_static (clutter_timeline_get_type (), "GalaSpringTimeline", &g_define_type_info, 0);
	GalaSpringTimeline_private_offset = g_type_add_instance_private (gala_spring_timeline_type_id, sizeof (GalaSpringTimelinePrivate));
	return gala_spring_timeline_type_id;
}

GType
gala_spring_timeline_get_type (void)
{
	static gsize gala_spring_timeline_type_id__once = 0;
	if (g_once_init_enter (&gala_spring_timeline_type_id__once)) {
		GType gala_spring_timeline_type_id;
		gala_spring_timeline_type_id = gala_spring_timeline_get_type_once ();
		g_once_init_leave (&gala_spring_timeline_type_id__once, gala_spring_timeline_type_id);
	}
	return gala_spring_timeline_type_id__once;
}

static void
_vala_gala_spring_timeline_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaSpringTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SPRING_TIMELINE, GalaSpringTimeline);
#line 15 "../src/Gestures/SpringTimeline.vala"
	switch (property_id) {
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_value_from (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_value_to (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_initial_velocity (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_DAMPING_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_damping (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_MASS_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_mass (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_stiffness (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_EPSILON_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_double (value, gala_spring_timeline_get_epsilon (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_CLAMP_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		g_value_set_boolean (value, gala_spring_timeline_get_clamp (self));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 1133 "SpringTimeline.c"
		default:
#line 15 "../src/Gestures/SpringTimeline.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 1139 "SpringTimeline.c"
	}
}

static void
_vala_gala_spring_timeline_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaSpringTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SPRING_TIMELINE, GalaSpringTimeline);
#line 15 "../src/Gestures/SpringTimeline.vala"
	switch (property_id) {
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_VALUE_FROM_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_value_from (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_VALUE_TO_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_value_to (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_INITIAL_VELOCITY_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_initial_velocity (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_DAMPING_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_damping (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_MASS_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_mass (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_STIFFNESS_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_stiffness (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_EPSILON_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_epsilon (self, g_value_get_double (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 15 "../src/Gestures/SpringTimeline.vala"
		case GALA_SPRING_TIMELINE_CLAMP_PROPERTY:
#line 15 "../src/Gestures/SpringTimeline.vala"
		gala_spring_timeline_set_clamp (self, g_value_get_boolean (value));
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 1201 "SpringTimeline.c"
		default:
#line 15 "../src/Gestures/SpringTimeline.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/Gestures/SpringTimeline.vala"
		break;
#line 1207 "SpringTimeline.c"
	}
}

