/* KeyboardManager.c generated by valac 0.56.18, the Vala compiler
 * generated from KeyboardManager.vala, do not modify */

/*
 * Copyright 2016 Santiago León
 * Copyright 2023-2025 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <meta/display.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <meta/window.h>
#include <clutter/clutter.h>
#include <meta/keybindings.h>
#include <meta/compositor.h>
#include <meta/meta-backend.h>
#include <meta/meta-context.h>
#include <meta/prefs.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_KEYBOARD_MANAGER (gala_keyboard_manager_get_type ())
#define GALA_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager))
#define GALA_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManagerClass))
#define GALA_IS_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_KEYBOARD_MANAGER))
#define GALA_IS_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_KEYBOARD_MANAGER))
#define GALA_KEYBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManagerClass))

typedef struct _GalaKeyboardManager GalaKeyboardManager;
typedef struct _GalaKeyboardManagerClass GalaKeyboardManagerClass;
typedef struct _GalaKeyboardManagerPrivate GalaKeyboardManagerPrivate;
enum  {
	GALA_KEYBOARD_MANAGER_0_PROPERTY,
	GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY,
	GALA_KEYBOARD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_keyboard_manager_properties[GALA_KEYBOARD_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GalaKeyboardManager {
	GObject parent_instance;
	GalaKeyboardManagerPrivate * priv;
};

struct _GalaKeyboardManagerClass {
	GObjectClass parent_class;
};

struct _GalaKeyboardManagerPrivate {
	MetaDisplay* _display;
	GSettings* settings;
};

static gint GalaKeyboardManager_private_offset;
static gpointer gala_keyboard_manager_parent_class = NULL;

VALA_EXTERN GType gala_keyboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaKeyboardManager, g_object_unref)
VALA_EXTERN GalaKeyboardManager* gala_keyboard_manager_new (MetaDisplay* display);
VALA_EXTERN GalaKeyboardManager* gala_keyboard_manager_construct (GType object_type,
                                                      MetaDisplay* display);
static void gala_keyboard_manager_handle_keybinding (GalaKeyboardManager* self,
                                              MetaDisplay* display,
                                              MetaWindow* window,
                                              ClutterKeyEvent* event,
                                              MetaKeyBinding* binding);
static gboolean gala_keyboard_manager_switch_input_source (GalaKeyboardManager* self,
                                                    gboolean backward);
static MetaDisplay* gala_keyboard_manager_get_display (GalaKeyboardManager* self);
static void gala_keyboard_manager_on_settings_changed (GalaKeyboardManager* self,
                                                const gchar* key);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gssize stack_length,
                                      const const gchar* needle);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void gala_keyboard_manager_set_display (GalaKeyboardManager* self,
                                        MetaDisplay* value);
static GObject * gala_keyboard_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _gala_keyboard_manager_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static gboolean _gala_keyboard_manager___lambda99_ (GalaKeyboardManager* self);
static gboolean __gala_keyboard_manager___lambda99__meta_display_modifiers_accelerator_activated (MetaDisplay* _sender,
                                                                                           gpointer self);
static void _gala_keyboard_manager_handle_keybinding_meta_key_handler_func (MetaDisplay* display,
                                                                     MetaWindow* window,
                                                                     const ClutterEvent* event,
                                                                     MetaKeyBinding* binding,
                                                                     gpointer self);
static void gala_keyboard_manager_finalize (GObject * obj);
static GType gala_keyboard_manager_get_type_once (void);
static void _vala_gala_keyboard_manager_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gala_keyboard_manager_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const gchar* GALA_KEYBOARD_MANAGER_BLOCKED_OPTIONS[8] = {"grp:alt_caps_toggle", "grp:alt_shift_toggle", "grp:alt_space_toggle", "grp:shifts_toggle", "grp:caps_toggle", "grp:ctrl_alt_toggle", "grp:ctrl_shift_toggle", "grp:shift_caps_toggle"};

static inline gpointer
gala_keyboard_manager_get_instance_private (GalaKeyboardManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaKeyboardManager_private_offset);
}

GalaKeyboardManager*
gala_keyboard_manager_construct (GType object_type,
                                 MetaDisplay* display)
{
	GalaKeyboardManager * self = NULL;
#line 18 "../src/KeyboardManager.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 19 "../src/KeyboardManager.vala"
	self = (GalaKeyboardManager*) g_object_new (object_type, "display", display, NULL);
#line 18 "../src/KeyboardManager.vala"
	return self;
#line 163 "KeyboardManager.c"
}

GalaKeyboardManager*
gala_keyboard_manager_new (MetaDisplay* display)
{
#line 18 "../src/KeyboardManager.vala"
	return gala_keyboard_manager_construct (GALA_TYPE_KEYBOARD_MANAGER, display);
#line 171 "KeyboardManager.c"
}

static void
gala_keyboard_manager_handle_keybinding (GalaKeyboardManager* self,
                                         MetaDisplay* display,
                                         MetaWindow* window,
                                         ClutterKeyEvent* event,
                                         MetaKeyBinding* binding)
{
	const gchar* _tmp0_;
#line 37 "../src/KeyboardManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/KeyboardManager.vala"
	g_return_if_fail (display != NULL);
#line 37 "../src/KeyboardManager.vala"
	g_return_if_fail (binding != NULL);
#line 40 "../src/KeyboardManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 40 "../src/KeyboardManager.vala"
	gala_keyboard_manager_switch_input_source (self, g_str_has_suffix (_tmp0_, "-backward"));
#line 192 "KeyboardManager.c"
}

static gboolean
gala_keyboard_manager_switch_input_source (GalaKeyboardManager* self,
                                           gboolean backward)
{
	MetaDisplay* _tmp0_;
	MetaCompositor* _tmp1_;
	MetaBackend* _tmp2_;
	MetaBackend* _tmp3_;
	MetaDisplay* _tmp4_;
	GVariant* sources = NULL;
	GSettings* _tmp5_;
	GVariant* _tmp6_;
	guint n_sources = 0U;
	GVariant* _tmp7_;
	guint current = 0U;
	GSettings* _tmp8_;
	gboolean result;
#line 43 "../src/KeyboardManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../src/KeyboardManager.vala"
	_tmp0_ = self->priv->_display;
#line 45 "../src/KeyboardManager.vala"
	_tmp1_ = meta_display_get_compositor (_tmp0_);
#line 45 "../src/KeyboardManager.vala"
	_tmp2_ = meta_compositor_get_backend (_tmp1_);
#line 45 "../src/KeyboardManager.vala"
	_tmp3_ = _tmp2_;
#line 45 "../src/KeyboardManager.vala"
	_tmp4_ = self->priv->_display;
#line 45 "../src/KeyboardManager.vala"
	meta_backend_ungrab_keyboard (_tmp3_, meta_display_get_current_time (_tmp4_));
#line 50 "../src/KeyboardManager.vala"
	_tmp5_ = self->priv->settings;
#line 50 "../src/KeyboardManager.vala"
	_tmp6_ = g_settings_get_value (_tmp5_, "sources");
#line 50 "../src/KeyboardManager.vala"
	sources = _tmp6_;
#line 52 "../src/KeyboardManager.vala"
	_tmp7_ = sources;
#line 52 "../src/KeyboardManager.vala"
	n_sources = (guint) g_variant_n_children (_tmp7_);
#line 53 "../src/KeyboardManager.vala"
	if (n_sources < ((guint) 2)) {
#line 54 "../src/KeyboardManager.vala"
		result = TRUE;
#line 54 "../src/KeyboardManager.vala"
		_g_variant_unref0 (sources);
#line 54 "../src/KeyboardManager.vala"
		return result;
#line 244 "KeyboardManager.c"
	}
#line 57 "../src/KeyboardManager.vala"
	_tmp8_ = self->priv->settings;
#line 57 "../src/KeyboardManager.vala"
	current = g_settings_get_uint (_tmp8_, "current");
#line 59 "../src/KeyboardManager.vala"
	if (!backward) {
#line 252 "KeyboardManager.c"
		GSettings* _tmp9_;
#line 60 "../src/KeyboardManager.vala"
		_tmp9_ = self->priv->settings;
#line 60 "../src/KeyboardManager.vala"
		g_settings_set_uint (_tmp9_, "current", (current + 1) % n_sources);
#line 258 "KeyboardManager.c"
	} else {
		GSettings* _tmp10_;
#line 62 "../src/KeyboardManager.vala"
		_tmp10_ = self->priv->settings;
#line 62 "../src/KeyboardManager.vala"
		g_settings_set_uint (_tmp10_, "current", (current - 1) % n_sources);
#line 265 "KeyboardManager.c"
	}
#line 65 "../src/KeyboardManager.vala"
	result = TRUE;
#line 65 "../src/KeyboardManager.vala"
	_g_variant_unref0 (sources);
#line 65 "../src/KeyboardManager.vala"
	return result;
#line 273 "KeyboardManager.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 81 "../src/KeyboardManager.vala"
	if ((*length) == (*size)) {
#line 81 "../src/KeyboardManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 81 "../src/KeyboardManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 288 "KeyboardManager.c"
	}
#line 81 "../src/KeyboardManager.vala"
	(*array)[(*length)++] = value;
#line 81 "../src/KeyboardManager.vala"
	(*array)[*length] = NULL;
#line 294 "KeyboardManager.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 82 "../src/KeyboardManager.vala"
	if ((*length) == (*size)) {
#line 82 "../src/KeyboardManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 82 "../src/KeyboardManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 309 "KeyboardManager.c"
	}
#line 82 "../src/KeyboardManager.vala"
	(*array)[(*length)++] = value;
#line 82 "../src/KeyboardManager.vala"
	(*array)[*length] = NULL;
#line 315 "KeyboardManager.c"
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gssize stack_length,
                             const const gchar* needle)
{
	gssize i;
#line 95 "../src/KeyboardManager.vala"
	for (i = 0; i < stack_length; i++) {
#line 95 "../src/KeyboardManager.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 95 "../src/KeyboardManager.vala"
			return TRUE;
#line 330 "KeyboardManager.c"
		}
	}
#line 95 "../src/KeyboardManager.vala"
	return FALSE;
#line 335 "KeyboardManager.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 96 "../src/KeyboardManager.vala"
	if ((*length) == (*size)) {
#line 96 "../src/KeyboardManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 96 "../src/KeyboardManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 350 "KeyboardManager.c"
	}
#line 96 "../src/KeyboardManager.vala"
	(*array)[(*length)++] = value;
#line 96 "../src/KeyboardManager.vala"
	(*array)[*length] = NULL;
#line 356 "KeyboardManager.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 370 "KeyboardManager.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 374 "KeyboardManager.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 380 "KeyboardManager.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 385 "KeyboardManager.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 391 "KeyboardManager.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 395 "KeyboardManager.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 399 "KeyboardManager.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 403 "KeyboardManager.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 407 "KeyboardManager.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 411 "KeyboardManager.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 426 "KeyboardManager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 435 "KeyboardManager.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 442 "KeyboardManager.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 448 "KeyboardManager.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 456 "KeyboardManager.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 460 "KeyboardManager.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 466 "KeyboardManager.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 471 "KeyboardManager.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 477 "KeyboardManager.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 481 "KeyboardManager.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 485 "KeyboardManager.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 491 "KeyboardManager.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 497 "KeyboardManager.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 509 "KeyboardManager.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 513 "KeyboardManager.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 517 "KeyboardManager.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 522 "KeyboardManager.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 530 "KeyboardManager.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 548 "KeyboardManager.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 554 "KeyboardManager.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 558 "KeyboardManager.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 566 "KeyboardManager.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 575 "KeyboardManager.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 584 "KeyboardManager.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 590 "KeyboardManager.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 598 "KeyboardManager.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 610 "KeyboardManager.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 616 "KeyboardManager.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 620 "KeyboardManager.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 628 "KeyboardManager.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 639 "KeyboardManager.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 648 "KeyboardManager.c"
	}
}

static void
gala_keyboard_manager_on_settings_changed (GalaKeyboardManager* self,
                                           const gchar* key)
{
	MetaBackend* backend = NULL;
	MetaDisplay* _tmp0_;
	MetaContext* _tmp1_;
	MetaBackend* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 68 "../src/KeyboardManager.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/KeyboardManager.vala"
	g_return_if_fail (key != NULL);
#line 69 "../src/KeyboardManager.vala"
	_tmp0_ = self->priv->_display;
#line 69 "../src/KeyboardManager.vala"
	_tmp1_ = meta_display_get_context (_tmp0_);
#line 69 "../src/KeyboardManager.vala"
	_tmp2_ = meta_context_get_backend (_tmp1_);
#line 69 "../src/KeyboardManager.vala"
	backend = _tmp2_;
#line 71 "../src/KeyboardManager.vala"
	if (g_strcmp0 (key, "sources") == 0) {
#line 71 "../src/KeyboardManager.vala"
		_tmp4_ = TRUE;
#line 678 "KeyboardManager.c"
	} else {
#line 71 "../src/KeyboardManager.vala"
		_tmp4_ = g_strcmp0 (key, "xkb-options") == 0;
#line 682 "KeyboardManager.c"
	}
#line 71 "../src/KeyboardManager.vala"
	if (_tmp4_) {
#line 71 "../src/KeyboardManager.vala"
		_tmp3_ = TRUE;
#line 688 "KeyboardManager.c"
	} else {
#line 71 "../src/KeyboardManager.vala"
		_tmp3_ = g_strcmp0 (key, "xkb-model") == 0;
#line 692 "KeyboardManager.c"
	}
#line 71 "../src/KeyboardManager.vala"
	if (_tmp3_) {
#line 696 "KeyboardManager.c"
		gchar** layouts = NULL;
		gchar** _tmp5_;
		gint layouts_length1;
		gint _layouts_size_;
		gchar** variants = NULL;
		gchar** _tmp6_;
		gint variants_length1;
		gint _variants_size_;
		GVariant* sources = NULL;
		GSettings* _tmp7_;
		GVariant* _tmp8_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		gchar** xkb_options = NULL;
		gchar** _tmp31_;
		gint xkb_options_length1;
		gint _xkb_options_size_;
		gchar** _tmp32_;
		gint _tmp32__length1;
		gchar* layout = NULL;
		gchar** _tmp42_;
		gint _tmp42__length1;
		gchar* _tmp43_;
		gchar* variant = NULL;
		gchar** _tmp44_;
		gint _tmp44__length1;
		gchar* _tmp45_;
		gchar* options = NULL;
		gchar** _tmp46_;
		gint _tmp46__length1;
		gchar* _tmp47_;
		MetaBackend* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		GSettings* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 72 "../src/KeyboardManager.vala"
		_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 72 "../src/KeyboardManager.vala"
		layouts = _tmp5_;
#line 72 "../src/KeyboardManager.vala"
		layouts_length1 = 0;
#line 72 "../src/KeyboardManager.vala"
		_layouts_size_ = layouts_length1;
#line 72 "../src/KeyboardManager.vala"
		_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 72 "../src/KeyboardManager.vala"
		variants = _tmp6_;
#line 72 "../src/KeyboardManager.vala"
		variants_length1 = 0;
#line 72 "../src/KeyboardManager.vala"
		_variants_size_ = variants_length1;
#line 74 "../src/KeyboardManager.vala"
		_tmp7_ = self->priv->settings;
#line 74 "../src/KeyboardManager.vala"
		_tmp8_ = g_settings_get_value (_tmp7_, "sources");
#line 74 "../src/KeyboardManager.vala"
		sources = _tmp8_;
#line 757 "KeyboardManager.c"
		{
			gint i = 0;
#line 75 "../src/KeyboardManager.vala"
			i = 0;
#line 762 "KeyboardManager.c"
			{
				gboolean _tmp9_ = FALSE;
#line 75 "../src/KeyboardManager.vala"
				_tmp9_ = TRUE;
#line 75 "../src/KeyboardManager.vala"
				while (TRUE) {
#line 769 "KeyboardManager.c"
					GVariant* _tmp11_;
					const gchar* type = NULL;
					const gchar* name = NULL;
					GVariant* _tmp12_;
					const gchar* _tmp13_ = NULL;
					const gchar* _tmp14_ = NULL;
					const gchar* _tmp15_;
#line 75 "../src/KeyboardManager.vala"
					if (!_tmp9_) {
#line 779 "KeyboardManager.c"
						gint _tmp10_;
#line 75 "../src/KeyboardManager.vala"
						_tmp10_ = i;
#line 75 "../src/KeyboardManager.vala"
						i = _tmp10_ + 1;
#line 785 "KeyboardManager.c"
					}
#line 75 "../src/KeyboardManager.vala"
					_tmp9_ = FALSE;
#line 75 "../src/KeyboardManager.vala"
					_tmp11_ = sources;
#line 75 "../src/KeyboardManager.vala"
					if (!(((gsize) i) < g_variant_n_children (_tmp11_))) {
#line 75 "../src/KeyboardManager.vala"
						break;
#line 795 "KeyboardManager.c"
					}
#line 76 "../src/KeyboardManager.vala"
					type = NULL;
#line 76 "../src/KeyboardManager.vala"
					name = NULL;
#line 77 "../src/KeyboardManager.vala"
					_tmp12_ = sources;
#line 77 "../src/KeyboardManager.vala"
					g_variant_get_child (_tmp12_, (gsize) i, "(&s&s)", &_tmp13_, &_tmp14_, NULL);
#line 77 "../src/KeyboardManager.vala"
					type = _tmp13_;
#line 77 "../src/KeyboardManager.vala"
					name = _tmp14_;
#line 79 "../src/KeyboardManager.vala"
					_tmp15_ = type;
#line 79 "../src/KeyboardManager.vala"
					if (g_strcmp0 (_tmp15_, "xkb") == 0) {
#line 813 "KeyboardManager.c"
						gchar** arr = NULL;
						const gchar* _tmp16_;
						gchar** _tmp17_;
						gchar** _tmp18_;
						gint arr_length1;
						gint _arr_size_;
						gchar** _tmp19_;
						gint _tmp19__length1;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						const gchar* _tmp22_ = NULL;
						gchar** _tmp23_;
						gint _tmp23__length1;
						const gchar* _tmp24_;
						gchar* _tmp25_;
#line 80 "../src/KeyboardManager.vala"
						_tmp16_ = name;
#line 80 "../src/KeyboardManager.vala"
						_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "+", 2);
#line 80 "../src/KeyboardManager.vala"
						arr = _tmp18_;
#line 80 "../src/KeyboardManager.vala"
						arr_length1 = _vala_array_length (_tmp17_);
#line 80 "../src/KeyboardManager.vala"
						_arr_size_ = arr_length1;
#line 81 "../src/KeyboardManager.vala"
						_tmp19_ = arr;
#line 81 "../src/KeyboardManager.vala"
						_tmp19__length1 = arr_length1;
#line 81 "../src/KeyboardManager.vala"
						_tmp20_ = _tmp19_[0];
#line 81 "../src/KeyboardManager.vala"
						_tmp21_ = g_strdup (_tmp20_);
#line 81 "../src/KeyboardManager.vala"
						_vala_array_add6 (&layouts, &layouts_length1, &_layouts_size_, _tmp21_);
#line 82 "../src/KeyboardManager.vala"
						_tmp23_ = arr;
#line 82 "../src/KeyboardManager.vala"
						_tmp23__length1 = arr_length1;
#line 82 "../src/KeyboardManager.vala"
						_tmp24_ = _tmp23_[1];
#line 82 "../src/KeyboardManager.vala"
						_tmp22_ = _tmp24_;
#line 82 "../src/KeyboardManager.vala"
						if (_tmp22_ == NULL) {
#line 82 "../src/KeyboardManager.vala"
							_tmp22_ = "";
#line 861 "KeyboardManager.c"
						}
#line 82 "../src/KeyboardManager.vala"
						_tmp25_ = g_strdup (_tmp22_);
#line 82 "../src/KeyboardManager.vala"
						_vala_array_add7 (&variants, &variants_length1, &_variants_size_, _tmp25_);
#line 79 "../src/KeyboardManager.vala"
						arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 869 "KeyboardManager.c"
					}
				}
			}
		}
#line 87 "../src/KeyboardManager.vala"
		_tmp26_ = layouts;
#line 87 "../src/KeyboardManager.vala"
		_tmp26__length1 = layouts_length1;
#line 87 "../src/KeyboardManager.vala"
		if (_tmp26__length1 == 0) {
#line 880 "KeyboardManager.c"
			gchar* _tmp27_;
			gchar** _tmp28_;
			gchar* _tmp29_;
			gchar** _tmp30_;
#line 88 "../src/KeyboardManager.vala"
			_tmp27_ = g_strdup ("us");
#line 88 "../src/KeyboardManager.vala"
			_tmp28_ = g_new0 (gchar*, 1 + 1);
#line 88 "../src/KeyboardManager.vala"
			_tmp28_[0] = _tmp27_;
#line 88 "../src/KeyboardManager.vala"
			layouts = (_vala_array_free (layouts, layouts_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/KeyboardManager.vala"
			layouts = _tmp28_;
#line 88 "../src/KeyboardManager.vala"
			layouts_length1 = 1;
#line 88 "../src/KeyboardManager.vala"
			_layouts_size_ = layouts_length1;
#line 89 "../src/KeyboardManager.vala"
			_tmp29_ = g_strdup ("");
#line 89 "../src/KeyboardManager.vala"
			_tmp30_ = g_new0 (gchar*, 1 + 1);
#line 89 "../src/KeyboardManager.vala"
			_tmp30_[0] = _tmp29_;
#line 89 "../src/KeyboardManager.vala"
			variants = (_vala_array_free (variants, variants_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/KeyboardManager.vala"
			variants = _tmp30_;
#line 89 "../src/KeyboardManager.vala"
			variants_length1 = 1;
#line 89 "../src/KeyboardManager.vala"
			_variants_size_ = variants_length1;
#line 913 "KeyboardManager.c"
		}
#line 92 "../src/KeyboardManager.vala"
		_tmp31_ = g_new0 (gchar*, 0 + 1);
#line 92 "../src/KeyboardManager.vala"
		xkb_options = _tmp31_;
#line 92 "../src/KeyboardManager.vala"
		xkb_options_length1 = 0;
#line 92 "../src/KeyboardManager.vala"
		_xkb_options_size_ = xkb_options_length1;
#line 93 "../src/KeyboardManager.vala"
		_tmp32_ = layouts;
#line 93 "../src/KeyboardManager.vala"
		_tmp32__length1 = layouts_length1;
#line 93 "../src/KeyboardManager.vala"
		if (_tmp32__length1 == 1) {
#line 929 "KeyboardManager.c"
			GSettings* _tmp33_;
			gchar** _tmp34_;
			gchar** _tmp35_;
#line 94 "../src/KeyboardManager.vala"
			_tmp33_ = self->priv->settings;
#line 94 "../src/KeyboardManager.vala"
			_tmp35_ = _tmp34_ = g_settings_get_strv (_tmp33_, "xkb-options");
#line 937 "KeyboardManager.c"
			{
				gchar** option_collection = NULL;
				gint option_collection_length1 = 0;
				gint _option_collection_size_ = 0;
				gint option_it = 0;
#line 94 "../src/KeyboardManager.vala"
				option_collection = _tmp35_;
#line 94 "../src/KeyboardManager.vala"
				option_collection_length1 = _vala_array_length (_tmp34_);
#line 94 "../src/KeyboardManager.vala"
				for (option_it = 0; option_it < option_collection_length1; option_it = option_it + 1) {
#line 949 "KeyboardManager.c"
					const gchar* option = NULL;
#line 94 "../src/KeyboardManager.vala"
					option = option_collection[option_it];
#line 953 "KeyboardManager.c"
					{
						const gchar* _tmp36_;
#line 95 "../src/KeyboardManager.vala"
						_tmp36_ = option;
#line 95 "../src/KeyboardManager.vala"
						if (!_vala_string_array_contains (GALA_KEYBOARD_MANAGER_BLOCKED_OPTIONS, G_N_ELEMENTS (GALA_KEYBOARD_MANAGER_BLOCKED_OPTIONS), _tmp36_)) {
#line 960 "KeyboardManager.c"
							const gchar* _tmp37_;
							gchar* _tmp38_;
#line 96 "../src/KeyboardManager.vala"
							_tmp37_ = option;
#line 96 "../src/KeyboardManager.vala"
							_tmp38_ = g_strdup (_tmp37_);
#line 96 "../src/KeyboardManager.vala"
							_vala_array_add8 (&xkb_options, &xkb_options_length1, &_xkb_options_size_, _tmp38_);
#line 969 "KeyboardManager.c"
						}
					}
				}
#line 94 "../src/KeyboardManager.vala"
				option_collection = (_vala_array_free (option_collection, option_collection_length1, (GDestroyNotify) g_free), NULL);
#line 975 "KeyboardManager.c"
			}
		} else {
			GSettings* _tmp39_;
			gchar** _tmp40_;
			gchar** _tmp41_;
#line 100 "../src/KeyboardManager.vala"
			_tmp39_ = self->priv->settings;
#line 100 "../src/KeyboardManager.vala"
			_tmp41_ = _tmp40_ = g_settings_get_strv (_tmp39_, "xkb-options");
#line 100 "../src/KeyboardManager.vala"
			xkb_options = (_vala_array_free (xkb_options, xkb_options_length1, (GDestroyNotify) g_free), NULL);
#line 100 "../src/KeyboardManager.vala"
			xkb_options = _tmp41_;
#line 100 "../src/KeyboardManager.vala"
			xkb_options_length1 = _vala_array_length (_tmp40_);
#line 100 "../src/KeyboardManager.vala"
			_xkb_options_size_ = xkb_options_length1;
#line 993 "KeyboardManager.c"
		}
#line 103 "../src/KeyboardManager.vala"
		_tmp42_ = layouts;
#line 103 "../src/KeyboardManager.vala"
		_tmp42__length1 = layouts_length1;
#line 103 "../src/KeyboardManager.vala"
		_tmp43_ = _vala_g_strjoinv (",", _tmp42_, (gint) _tmp42__length1);
#line 103 "../src/KeyboardManager.vala"
		layout = _tmp43_;
#line 104 "../src/KeyboardManager.vala"
		_tmp44_ = variants;
#line 104 "../src/KeyboardManager.vala"
		_tmp44__length1 = variants_length1;
#line 104 "../src/KeyboardManager.vala"
		_tmp45_ = _vala_g_strjoinv (",", _tmp44_, (gint) _tmp44__length1);
#line 104 "../src/KeyboardManager.vala"
		variant = _tmp45_;
#line 105 "../src/KeyboardManager.vala"
		_tmp46_ = xkb_options;
#line 105 "../src/KeyboardManager.vala"
		_tmp46__length1 = xkb_options_length1;
#line 105 "../src/KeyboardManager.vala"
		_tmp47_ = _vala_g_strjoinv (",", _tmp46_, (gint) _tmp46__length1);
#line 105 "../src/KeyboardManager.vala"
		options = _tmp47_;
#line 108 "../src/KeyboardManager.vala"
		_tmp48_ = backend;
#line 108 "../src/KeyboardManager.vala"
		_tmp49_ = layout;
#line 108 "../src/KeyboardManager.vala"
		_tmp50_ = variant;
#line 108 "../src/KeyboardManager.vala"
		_tmp51_ = options;
#line 108 "../src/KeyboardManager.vala"
		_tmp52_ = self->priv->settings;
#line 108 "../src/KeyboardManager.vala"
		_tmp53_ = g_settings_get_string (_tmp52_, "xkb-model");
#line 108 "../src/KeyboardManager.vala"
		_tmp54_ = _tmp53_;
#line 108 "../src/KeyboardManager.vala"
		meta_backend_set_keymap (_tmp48_, _tmp49_, _tmp50_, _tmp51_, _tmp54_);
#line 108 "../src/KeyboardManager.vala"
		_g_free0 (_tmp54_);
#line 71 "../src/KeyboardManager.vala"
		_g_free0 (options);
#line 71 "../src/KeyboardManager.vala"
		_g_free0 (variant);
#line 71 "../src/KeyboardManager.vala"
		_g_free0 (layout);
#line 71 "../src/KeyboardManager.vala"
		xkb_options = (_vala_array_free (xkb_options, xkb_options_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/KeyboardManager.vala"
		_g_variant_unref0 (sources);
#line 71 "../src/KeyboardManager.vala"
		variants = (_vala_array_free (variants, variants_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/KeyboardManager.vala"
		layouts = (_vala_array_free (layouts, layouts_length1, (GDestroyNotify) g_free), NULL);
#line 1051 "KeyboardManager.c"
	} else {
#line 112 "../src/KeyboardManager.vala"
		if (g_strcmp0 (key, "current") == 0) {
#line 1055 "KeyboardManager.c"
			MetaBackend* _tmp55_;
			GSettings* _tmp56_;
#line 113 "../src/KeyboardManager.vala"
			_tmp55_ = backend;
#line 113 "../src/KeyboardManager.vala"
			_tmp56_ = self->priv->settings;
#line 113 "../src/KeyboardManager.vala"
			meta_backend_lock_layout_group (_tmp55_, g_settings_get_uint (_tmp56_, "current"));
#line 1064 "KeyboardManager.c"
		}
	}
}

static MetaDisplay*
gala_keyboard_manager_get_display (GalaKeyboardManager* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 14 "../src/KeyboardManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/KeyboardManager.vala"
	_tmp0_ = self->priv->_display;
#line 14 "../src/KeyboardManager.vala"
	result = _tmp0_;
#line 14 "../src/KeyboardManager.vala"
	return result;
#line 1082 "KeyboardManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 14 "../src/KeyboardManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1090 "KeyboardManager.c"
}

static void
gala_keyboard_manager_set_display (GalaKeyboardManager* self,
                                   MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 14 "../src/KeyboardManager.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/KeyboardManager.vala"
	old_value = gala_keyboard_manager_get_display (self);
#line 14 "../src/KeyboardManager.vala"
	if (old_value != value) {
#line 1104 "KeyboardManager.c"
		MetaDisplay* _tmp0_;
#line 14 "../src/KeyboardManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/KeyboardManager.vala"
		_g_object_unref0 (self->priv->_display);
#line 14 "../src/KeyboardManager.vala"
		self->priv->_display = _tmp0_;
#line 14 "../src/KeyboardManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_keyboard_manager_properties[GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY]);
#line 1114 "KeyboardManager.c"
	}
}

static void
_gala_keyboard_manager_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 28 "../src/KeyboardManager.vala"
	gala_keyboard_manager_on_settings_changed ((GalaKeyboardManager*) self, key);
#line 1125 "KeyboardManager.c"
}

static gboolean
_gala_keyboard_manager___lambda99_ (GalaKeyboardManager* self)
{
	gboolean result;
#line 30 "../src/KeyboardManager.vala"
	result = gala_keyboard_manager_switch_input_source (self, FALSE);
#line 30 "../src/KeyboardManager.vala"
	return result;
#line 1136 "KeyboardManager.c"
}

static gboolean
__gala_keyboard_manager___lambda99__meta_display_modifiers_accelerator_activated (MetaDisplay* _sender,
                                                                                  gpointer self)
{
	gboolean result;
	result = _gala_keyboard_manager___lambda99_ ((GalaKeyboardManager*) self);
#line 30 "../src/KeyboardManager.vala"
	return result;
#line 1147 "KeyboardManager.c"
}

static void
_gala_keyboard_manager_handle_keybinding_meta_key_handler_func (MetaDisplay* display,
                                                                MetaWindow* window,
                                                                const ClutterEvent* event,
                                                                MetaKeyBinding* binding,
                                                                gpointer self)
{
#line 33 "../src/KeyboardManager.vala"
	gala_keyboard_manager_handle_keybinding ((GalaKeyboardManager*) self, display, window, event, binding);
#line 1159 "KeyboardManager.c"
}

static GObject *
gala_keyboard_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaKeyboardManager * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	MetaDisplay* _tmp2_;
	GSettings* keybinding_settings = NULL;
	GSettings* _tmp3_;
	MetaDisplay* _tmp4_;
	GSettings* _tmp5_;
	MetaDisplay* _tmp6_;
	GSettings* _tmp7_;
#line 22 "../src/KeyboardManager.vala"
	parent_class = G_OBJECT_CLASS (gala_keyboard_manager_parent_class);
#line 22 "../src/KeyboardManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 22 "../src/KeyboardManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager);
#line 23 "../src/KeyboardManager.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.input-sources");
#line 23 "../src/KeyboardManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 23 "../src/KeyboardManager.vala"
	self->priv->settings = _tmp0_;
#line 25 "../src/KeyboardManager.vala"
	gala_keyboard_manager_on_settings_changed (self, "sources");
#line 26 "../src/KeyboardManager.vala"
	gala_keyboard_manager_on_settings_changed (self, "current");
#line 28 "../src/KeyboardManager.vala"
	_tmp1_ = self->priv->settings;
#line 28 "../src/KeyboardManager.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _gala_keyboard_manager_on_settings_changed_g_settings_changed, self, 0);
#line 30 "../src/KeyboardManager.vala"
	_tmp2_ = self->priv->_display;
#line 30 "../src/KeyboardManager.vala"
	g_signal_connect_object (_tmp2_, "modifiers-accelerator-activated", (GCallback) __gala_keyboard_manager___lambda99__meta_display_modifiers_accelerator_activated, self, 0);
#line 32 "../src/KeyboardManager.vala"
	_tmp3_ = g_settings_new ("io.elementary.desktop.wm.keybindings");
#line 32 "../src/KeyboardManager.vala"
	keybinding_settings = _tmp3_;
#line 33 "../src/KeyboardManager.vala"
	_tmp4_ = self->priv->_display;
#line 33 "../src/KeyboardManager.vala"
	_tmp5_ = keybinding_settings;
#line 33 "../src/KeyboardManager.vala"
	meta_display_add_keybinding (_tmp4_, "switch-input-source", _tmp5_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_keyboard_manager_handle_keybinding_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 34 "../src/KeyboardManager.vala"
	_tmp6_ = self->priv->_display;
#line 34 "../src/KeyboardManager.vala"
	_tmp7_ = keybinding_settings;
#line 34 "../src/KeyboardManager.vala"
	meta_display_add_keybinding (_tmp6_, "switch-input-source-backward", _tmp7_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_keyboard_manager_handle_keybinding_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 22 "../src/KeyboardManager.vala"
	_g_object_unref0 (keybinding_settings);
#line 22 "../src/KeyboardManager.vala"
	return obj;
#line 1223 "KeyboardManager.c"
}

static void
gala_keyboard_manager_class_init (GalaKeyboardManagerClass * klass,
                                  gpointer klass_data)
{
#line 7 "../src/KeyboardManager.vala"
	gala_keyboard_manager_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/KeyboardManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaKeyboardManager_private_offset);
#line 7 "../src/KeyboardManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_keyboard_manager_get_property;
#line 7 "../src/KeyboardManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_keyboard_manager_set_property;
#line 7 "../src/KeyboardManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_keyboard_manager_constructor;
#line 7 "../src/KeyboardManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_keyboard_manager_finalize;
#line 7 "../src/KeyboardManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY, gala_keyboard_manager_properties[GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1244 "KeyboardManager.c"
}

static void
gala_keyboard_manager_instance_init (GalaKeyboardManager * self,
                                     gpointer klass)
{
#line 7 "../src/KeyboardManager.vala"
	self->priv = gala_keyboard_manager_get_instance_private (self);
#line 1253 "KeyboardManager.c"
}

static void
gala_keyboard_manager_finalize (GObject * obj)
{
	GalaKeyboardManager * self;
#line 7 "../src/KeyboardManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager);
#line 14 "../src/KeyboardManager.vala"
	_g_object_unref0 (self->priv->_display);
#line 16 "../src/KeyboardManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 7 "../src/KeyboardManager.vala"
	G_OBJECT_CLASS (gala_keyboard_manager_parent_class)->finalize (obj);
#line 1268 "KeyboardManager.c"
}

 G_GNUC_NO_INLINE static GType
gala_keyboard_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaKeyboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_keyboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaKeyboardManager), 0, (GInstanceInitFunc) gala_keyboard_manager_instance_init, NULL };
	GType gala_keyboard_manager_type_id;
	gala_keyboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaKeyboardManager", &g_define_type_info, 0);
	GalaKeyboardManager_private_offset = g_type_add_instance_private (gala_keyboard_manager_type_id, sizeof (GalaKeyboardManagerPrivate));
	return gala_keyboard_manager_type_id;
}

GType
gala_keyboard_manager_get_type (void)
{
	static gsize gala_keyboard_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_keyboard_manager_type_id__once)) {
		GType gala_keyboard_manager_type_id;
		gala_keyboard_manager_type_id = gala_keyboard_manager_get_type_once ();
		g_once_init_leave (&gala_keyboard_manager_type_id__once, gala_keyboard_manager_type_id);
	}
	return gala_keyboard_manager_type_id__once;
}

static void
_vala_gala_keyboard_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GalaKeyboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager);
#line 7 "../src/KeyboardManager.vala"
	switch (property_id) {
#line 7 "../src/KeyboardManager.vala"
		case GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY:
#line 7 "../src/KeyboardManager.vala"
		g_value_set_object (value, gala_keyboard_manager_get_display (self));
#line 7 "../src/KeyboardManager.vala"
		break;
#line 1309 "KeyboardManager.c"
		default:
#line 7 "../src/KeyboardManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/KeyboardManager.vala"
		break;
#line 1315 "KeyboardManager.c"
	}
}

static void
_vala_gala_keyboard_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GalaKeyboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager);
#line 7 "../src/KeyboardManager.vala"
	switch (property_id) {
#line 7 "../src/KeyboardManager.vala"
		case GALA_KEYBOARD_MANAGER_DISPLAY_PROPERTY:
#line 7 "../src/KeyboardManager.vala"
		gala_keyboard_manager_set_display (self, g_value_get_object (value));
#line 7 "../src/KeyboardManager.vala"
		break;
#line 1335 "KeyboardManager.c"
		default:
#line 7 "../src/KeyboardManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/KeyboardManager.vala"
		break;
#line 1341 "KeyboardManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

