/* PluginManager.c generated by valac 0.56.18, the Vala compiler
 * generated from PluginManager.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2014 Tom Beckmann
 *                         2025 elementary, Inc. (https://elementary.io)
 */

#include <glib-object.h>
#include <glib.h>
#include <X11/Xlib.h>
#include <stdlib.h>
#include <string.h>
#include "gala.h"
#include <gio/gio.h>
#include <gee.h>
#include <gmodule.h>
#include "config.h"
#include <mtk/mtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_PLUGIN_MANAGER (gala_plugin_manager_get_type ())
#define GALA_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager))
#define GALA_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))
#define GALA_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))

typedef struct _GalaPluginManager GalaPluginManager;
typedef struct _GalaPluginManagerClass GalaPluginManagerClass;
typedef struct _GalaPluginManagerPrivate GalaPluginManagerPrivate;
enum  {
	GALA_PLUGIN_MANAGER_0_PROPERTY,
	GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY,
	GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
typedef void (*GalaPluginManagerRegisterPluginFunction) (GalaPluginInfo* result, gpointer user_data);
#define __vala_GalaPluginInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_GalaPluginInfo_free (var), NULL)))
typedef struct _Block8Data Block8Data;
enum  {
	GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL,
	GALA_PLUGIN_MANAGER_NUM_SIGNALS
};
static guint gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_NUM_SIGNALS] = {0};

struct _GalaPluginManager {
	GObject parent_instance;
	GalaPluginManagerPrivate * priv;
};

struct _GalaPluginManagerClass {
	GObjectClass parent_class;
};

struct _GalaPluginManagerPrivate {
	gboolean _initialized;
	XRectangle* _regions;
	gint _regions_length1;
	gint __regions_size_;
	gchar* _window_switcher_provider;
	gchar* _window_overview_provider;
	GHashTable* plugins;
	GFile* plugin_dir;
	GalaWindowManager* wm;
	GeeLinkedList* load_later_plugins;
};

struct _Block8Data {
	int _ref_count_;
	GalaPluginManager* self;
	XRectangle* regions;
	gint regions_length1;
	gint _regions_size_;
};

static gint GalaPluginManager_private_offset;
static gpointer gala_plugin_manager_parent_class = NULL;
static GalaPluginManager* gala_plugin_manager_instance;
static GalaPluginManager* gala_plugin_manager_instance = NULL;

VALA_EXTERN GType gala_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPluginManager, g_object_unref)
VALA_EXTERN GalaPluginManager* gala_plugin_manager_get_default (void);
static GalaPluginManager* gala_plugin_manager_new (void);
static GalaPluginManager* gala_plugin_manager_construct (GType object_type);
VALA_EXTERN XRectangle* gala_plugin_manager_get_regions (GalaPluginManager* self,
                                             gint* result_length1);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static GalaPluginInfo* _gala_plugin_info_dup (GalaPluginInfo* self);
static void _vala_GalaPluginInfo_free (GalaPluginInfo* self);
static gboolean gala_plugin_manager_load_module (GalaPluginManager* self,
                                          const gchar* plugin_name);
static void ___lambda14_ (GalaPluginManager* self,
                   GFile* file,
                   GFile* other_file,
                   GFileMonitorEvent type);
static void ____lambda14__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static gboolean gala_plugin_manager_check_provides (GalaPluginManager* self,
                                             const gchar* name,
                                             GalaPluginFunction provides);
VALA_EXTERN gboolean gala_plugin_manager_get_initialized (GalaPluginManager* self);
static void gala_plugin_manager_load_plugin_class (GalaPluginManager* self,
                                            GalaPluginInfo* info);
static void gala_plugin_manager_initialize_plugin (GalaPluginManager* self,
                                            const gchar* plugin_name,
                                            GalaPlugin* plugin);
static void gala_plugin_manager_recalculate_regions (GalaPluginManager* self);
static void _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender,
                                                                          gpointer self);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self,
                                                       const gchar* value);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self,
                                                       const gchar* value);
VALA_EXTERN void gala_plugin_manager_initialize (GalaPluginManager* self,
                                     GalaWindowManager* _wm);
static void _gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key,
                                                     gconstpointer value,
                                                     gpointer self);
static void gala_plugin_manager_set_initialized (GalaPluginManager* self,
                                          gboolean value);
VALA_EXTERN void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self);
VALA_EXTERN GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                            const gchar* id);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda13_ (Block8Data* _data8_,
                  const gchar* name,
                  GalaPlugin* plugin);
static void _vala_array_add9 (XRectangle* * array,
                       gint* length,
                       gint* size,
                       XRectangle value);
static void ___lambda13__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static XRectangle* _vala_array_dup1 (XRectangle* self,
                              gssize length);
static void gala_plugin_manager_finalize (GObject * obj);
static GType gala_plugin_manager_get_type_once (void);
static void _vala_gala_plugin_manager_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_gala_plugin_manager_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
gala_plugin_manager_get_instance_private (GalaPluginManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginManager_private_offset);
}

GalaPluginManager*
gala_plugin_manager_get_default (void)
{
	GalaPluginManager* _tmp0_;
	GalaPluginManager* _tmp2_;
	GalaPluginManager* result;
#line 10 "../src/PluginManager.vala"
	_tmp0_ = gala_plugin_manager_instance;
#line 10 "../src/PluginManager.vala"
	if (_tmp0_ == NULL) {
#line 199 "PluginManager.c"
		GalaPluginManager* _tmp1_;
#line 11 "../src/PluginManager.vala"
		_tmp1_ = gala_plugin_manager_new ();
#line 11 "../src/PluginManager.vala"
		_g_object_unref0 (gala_plugin_manager_instance);
#line 11 "../src/PluginManager.vala"
		gala_plugin_manager_instance = _tmp1_;
#line 207 "PluginManager.c"
	}
#line 13 "../src/PluginManager.vala"
	_tmp2_ = gala_plugin_manager_instance;
#line 13 "../src/PluginManager.vala"
	result = _tmp2_;
#line 13 "../src/PluginManager.vala"
	return result;
#line 215 "PluginManager.c"
}

XRectangle*
gala_plugin_manager_get_regions (GalaPluginManager* self,
                                 gint* result_length1)
{
	XRectangle* _tmp0_;
	gint _tmp0__length1;
	XRectangle* _tmp1_;
	gint _tmp1__length1;
	XRectangle* result;
#line 23 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/PluginManager.vala"
	_tmp0_ = self->priv->_regions;
#line 24 "../src/PluginManager.vala"
	_tmp0__length1 = self->priv->_regions_length1;
#line 24 "../src/PluginManager.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/PluginManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 24 "../src/PluginManager.vala"
	if (result_length1) {
#line 24 "../src/PluginManager.vala"
		*result_length1 = _tmp1__length1;
#line 241 "PluginManager.c"
	}
#line 24 "../src/PluginManager.vala"
	result = _tmp1_;
#line 24 "../src/PluginManager.vala"
	return result;
#line 247 "PluginManager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 38 "../src/PluginManager.vala"
	var = (g_free (var), NULL);
#line 255 "PluginManager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 38 "../src/PluginManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 263 "PluginManager.c"
}

static GalaPluginInfo*
_gala_plugin_info_dup (GalaPluginInfo* self)
{
	GalaPluginInfo* dup;
#line 39 "../src/PluginManager.vala"
	dup = g_new0 (GalaPluginInfo, 1);
#line 39 "../src/PluginManager.vala"
	gala_plugin_info_copy (self, dup);
#line 39 "../src/PluginManager.vala"
	return dup;
#line 276 "PluginManager.c"
}

static void
_vala_GalaPluginInfo_free (GalaPluginInfo* self)
{
#line 39 "../src/PluginManager.vala"
	gala_plugin_info_destroy (self);
#line 39 "../src/PluginManager.vala"
	g_free (self);
#line 286 "PluginManager.c"
}

static void
___lambda14_ (GalaPluginManager* self,
              GFile* file,
              GFile* other_file,
              GFileMonitorEvent type)
{
#line 63 "../src/PluginManager.vala"
	g_return_if_fail (file != NULL);
#line 64 "../src/PluginManager.vala"
	if (type == G_FILE_MONITOR_EVENT_CREATED) {
#line 299 "PluginManager.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 65 "../src/PluginManager.vala"
		_tmp0_ = g_file_get_basename (file);
#line 65 "../src/PluginManager.vala"
		_tmp1_ = _tmp0_;
#line 65 "../src/PluginManager.vala"
		gala_plugin_manager_load_module (self, _tmp1_);
#line 65 "../src/PluginManager.vala"
		_g_free0 (_tmp1_);
#line 310 "PluginManager.c"
	}
}

static void
____lambda14__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 63 "../src/PluginManager.vala"
	___lambda14_ ((GalaPluginManager*) self, file, other_file, event_type);
#line 323 "PluginManager.c"
}

static GalaPluginManager*
gala_plugin_manager_construct (GType object_type)
{
	GalaPluginManager * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GeeLinkedList* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 37 "../src/PluginManager.vala"
	self = (GalaPluginManager*) g_object_new (object_type, NULL);
#line 38 "../src/PluginManager.vala"
	_tmp0_ = g_str_hash;
#line 38 "../src/PluginManager.vala"
	_tmp1_ = g_str_equal;
#line 38 "../src/PluginManager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 38 "../src/PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 38 "../src/PluginManager.vala"
	self->priv->plugins = _tmp2_;
#line 39 "../src/PluginManager.vala"
	_tmp3_ = gee_linked_list_new (GALA_TYPE_PLUGIN_INFO, (GBoxedCopyFunc) _gala_plugin_info_dup, (GDestroyNotify) _vala_GalaPluginInfo_free, NULL, NULL, NULL);
#line 39 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 39 "../src/PluginManager.vala"
	self->priv->load_later_plugins = _tmp3_;
#line 41 "../src/PluginManager.vala"
	if (!g_module_supported ()) {
#line 42 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:42: Modules are not supported on this platform");
#line 43 "../src/PluginManager.vala"
		return self;
#line 361 "PluginManager.c"
	}
#line 46 "../src/PluginManager.vala"
	_tmp4_ = g_file_new_for_path (PLUGINDIR);
#line 46 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 46 "../src/PluginManager.vala"
	self->priv->plugin_dir = _tmp4_;
#line 47 "../src/PluginManager.vala"
	_tmp5_ = self->priv->plugin_dir;
#line 47 "../src/PluginManager.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 48 "../src/PluginManager.vala"
		return self;
#line 375 "PluginManager.c"
	}
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp6_;
		GFileEnumerator* _tmp7_;
		GFileInfo* info = NULL;
#line 51 "../src/PluginManager.vala"
		_tmp6_ = self->priv->plugin_dir;
#line 51 "../src/PluginManager.vala"
		_tmp7_ = g_file_enumerate_children (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
#line 51 "../src/PluginManager.vala"
		enumerator = _tmp7_;
#line 51 "../src/PluginManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "PluginManager.c"
			goto __catch0_g_error;
		}
#line 54 "../src/PluginManager.vala"
		while (TRUE) {
#line 395 "PluginManager.c"
			GFileInfo* _tmp8_ = NULL;
			GFileEnumerator* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GFileInfo* _tmp12_;
			GFileInfo* _tmp13_;
			const gchar* _tmp14_;
#line 54 "../src/PluginManager.vala"
			_tmp9_ = enumerator;
#line 54 "../src/PluginManager.vala"
			_tmp10_ = g_file_enumerator_next_file (_tmp9_, NULL, &_inner_error0_);
#line 54 "../src/PluginManager.vala"
			_tmp8_ = _tmp10_;
#line 54 "../src/PluginManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/PluginManager.vala"
				_g_object_unref0 (info);
#line 54 "../src/PluginManager.vala"
				_g_object_unref0 (enumerator);
#line 415 "PluginManager.c"
				goto __catch0_g_error;
			}
#line 54 "../src/PluginManager.vala"
			_tmp11_ = _tmp8_;
#line 54 "../src/PluginManager.vala"
			_tmp8_ = NULL;
#line 54 "../src/PluginManager.vala"
			_g_object_unref0 (info);
#line 54 "../src/PluginManager.vala"
			info = _tmp11_;
#line 54 "../src/PluginManager.vala"
			_tmp12_ = info;
#line 54 "../src/PluginManager.vala"
			if (!(_tmp12_ != NULL)) {
#line 54 "../src/PluginManager.vala"
				_g_object_unref0 (_tmp8_);
#line 54 "../src/PluginManager.vala"
				break;
#line 434 "PluginManager.c"
			}
#line 55 "../src/PluginManager.vala"
			_tmp13_ = info;
#line 55 "../src/PluginManager.vala"
			_tmp14_ = g_file_info_get_content_type (_tmp13_);
#line 55 "../src/PluginManager.vala"
			if (g_strcmp0 (_tmp14_, "application/x-sharedlib") == 0) {
#line 442 "PluginManager.c"
				GFileInfo* _tmp15_;
				const gchar* _tmp16_;
#line 56 "../src/PluginManager.vala"
				_tmp15_ = info;
#line 56 "../src/PluginManager.vala"
				_tmp16_ = g_file_info_get_name (_tmp15_);
#line 56 "../src/PluginManager.vala"
				gala_plugin_manager_load_module (self, _tmp16_);
#line 451 "PluginManager.c"
			}
#line 54 "../src/PluginManager.vala"
			_g_object_unref0 (_tmp8_);
#line 455 "PluginManager.c"
		}
#line 50 "../src/PluginManager.vala"
		_g_object_unref0 (info);
#line 50 "../src/PluginManager.vala"
		_g_object_unref0 (enumerator);
#line 461 "PluginManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 50 "../src/PluginManager.vala"
		e = _inner_error0_;
#line 50 "../src/PluginManager.vala"
		_inner_error0_ = NULL;
#line 59 "../src/PluginManager.vala"
		_tmp17_ = e;
#line 59 "../src/PluginManager.vala"
		_tmp18_ = _tmp17_->message;
#line 59 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:59: %s", _tmp18_);
#line 50 "../src/PluginManager.vala"
		_g_error_free0 (e);
#line 481 "PluginManager.c"
	}
	__finally0:
#line 50 "../src/PluginManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 50 "../src/PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../src/PluginManager.vala"
		g_clear_error (&_inner_error0_);
#line 50 "../src/PluginManager.vala"
		return NULL;
#line 492 "PluginManager.c"
	}
	{
		GFileMonitor* _tmp19_ = NULL;
		GFile* _tmp20_;
		GFileMonitor* _tmp21_;
#line 63 "../src/PluginManager.vala"
		_tmp20_ = self->priv->plugin_dir;
#line 63 "../src/PluginManager.vala"
		_tmp21_ = g_file_monitor_directory (_tmp20_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 63 "../src/PluginManager.vala"
		_tmp19_ = _tmp21_;
#line 63 "../src/PluginManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 506 "PluginManager.c"
			goto __catch1_g_error;
		}
#line 63 "../src/PluginManager.vala"
		g_signal_connect_object (_tmp19_, "changed", (GCallback) ____lambda14__g_file_monitor_changed, self, 0);
#line 62 "../src/PluginManager.vala"
		_g_object_unref0 (_tmp19_);
#line 513 "PluginManager.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 62 "../src/PluginManager.vala"
		e = _inner_error0_;
#line 62 "../src/PluginManager.vala"
		_inner_error0_ = NULL;
#line 69 "../src/PluginManager.vala"
		_tmp22_ = e;
#line 69 "../src/PluginManager.vala"
		_tmp23_ = _tmp22_->message;
#line 69 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:69: %s", _tmp23_);
#line 62 "../src/PluginManager.vala"
		_g_error_free0 (e);
#line 533 "PluginManager.c"
	}
	__finally1:
#line 62 "../src/PluginManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/PluginManager.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../src/PluginManager.vala"
		return NULL;
#line 544 "PluginManager.c"
	}
#line 37 "../src/PluginManager.vala"
	return self;
#line 548 "PluginManager.c"
}

static GalaPluginManager*
gala_plugin_manager_new (void)
{
#line 37 "../src/PluginManager.vala"
	return gala_plugin_manager_construct (GALA_TYPE_PLUGIN_MANAGER);
#line 556 "PluginManager.c"
}

static gboolean
gala_plugin_manager_load_module (GalaPluginManager* self,
                                 const gchar* plugin_name)
{
	gchar* path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GModule* module = NULL;
	const gchar* _tmp5_;
	GModule* _tmp6_;
	GModule* _tmp7_;
	void* function = NULL;
	GModule* _tmp9_;
	void* _tmp10_ = NULL;
	void* _tmp11_;
	GalaPluginManagerRegisterPluginFunction _register_ = NULL;
	void* _tmp12_;
	gpointer _register__target;
	GalaPluginInfo info = {0};
	GalaPluginManagerRegisterPluginFunction _tmp13_;
	gpointer _tmp13__target;
	GalaPluginInfo _tmp14_ = {0};
	GalaPluginInfo _tmp15_;
	GalaPluginInfo _tmp16_;
	const gchar* _tmp17_;
	GalaPluginInfo _tmp18_;
	gchar* _tmp19_;
	GModule* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GalaPluginInfo _tmp22_;
	gboolean result;
#line 73 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/PluginManager.vala"
	g_return_val_if_fail (plugin_name != NULL, FALSE);
#line 74 "../src/PluginManager.vala"
	_tmp0_ = self->priv->plugin_dir;
#line 74 "../src/PluginManager.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 74 "../src/PluginManager.vala"
	_tmp2_ = _tmp1_;
#line 74 "../src/PluginManager.vala"
	_tmp3_ = g_module_build_path (_tmp2_, plugin_name);
#line 74 "../src/PluginManager.vala"
	_tmp4_ = _tmp3_;
#line 74 "../src/PluginManager.vala"
	_g_free0 (_tmp2_);
#line 74 "../src/PluginManager.vala"
	path = _tmp4_;
#line 75 "../src/PluginManager.vala"
	_tmp5_ = path;
#line 75 "../src/PluginManager.vala"
	_tmp6_ = g_module_open (_tmp5_, G_MODULE_BIND_LOCAL);
#line 75 "../src/PluginManager.vala"
	module = _tmp6_;
#line 76 "../src/PluginManager.vala"
	_tmp7_ = module;
#line 76 "../src/PluginManager.vala"
	if (_tmp7_ == NULL) {
#line 621 "PluginManager.c"
		const gchar* _tmp8_;
#line 77 "../src/PluginManager.vala"
		_tmp8_ = g_module_error ();
#line 77 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:77: %s", _tmp8_);
#line 78 "../src/PluginManager.vala"
		result = FALSE;
#line 78 "../src/PluginManager.vala"
		_g_module_close0 (module);
#line 78 "../src/PluginManager.vala"
		_g_free0 (path);
#line 78 "../src/PluginManager.vala"
		return result;
#line 635 "PluginManager.c"
	}
#line 82 "../src/PluginManager.vala"
	_tmp9_ = module;
#line 82 "../src/PluginManager.vala"
	g_module_symbol (_tmp9_, "register_plugin", &_tmp10_);
#line 82 "../src/PluginManager.vala"
	function = _tmp10_;
#line 83 "../src/PluginManager.vala"
	_tmp11_ = function;
#line 83 "../src/PluginManager.vala"
	if (_tmp11_ == NULL) {
#line 84 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:84: %s failed to register: register_plugin() functi" \
"on not found", plugin_name);
#line 85 "../src/PluginManager.vala"
		result = FALSE;
#line 85 "../src/PluginManager.vala"
		_g_module_close0 (module);
#line 85 "../src/PluginManager.vala"
		_g_free0 (path);
#line 85 "../src/PluginManager.vala"
		return result;
#line 657 "PluginManager.c"
	}
#line 87 "../src/PluginManager.vala"
	_tmp12_ = function;
#line 87 "../src/PluginManager.vala"
	_register_ = (GalaPluginManagerRegisterPluginFunction) _tmp12_;
#line 87 "../src/PluginManager.vala"
	_register__target = NULL;
#line 89 "../src/PluginManager.vala"
	_tmp13_ = _register_;
#line 89 "../src/PluginManager.vala"
	_tmp13__target = _register__target;
#line 89 "../src/PluginManager.vala"
	_tmp13_ (&_tmp14_, _tmp13__target);
#line 89 "../src/PluginManager.vala"
	info = _tmp14_;
#line 90 "../src/PluginManager.vala"
	_tmp15_ = info;
#line 90 "../src/PluginManager.vala"
	if (g_type_is_a (_tmp15_.plugin_type, GALA_TYPE_PLUGIN) == FALSE) {
#line 91 "../src/PluginManager.vala"
		g_warning ("PluginManager.vala:91: %s does not return a class of type Plugin", plugin_name);
#line 92 "../src/PluginManager.vala"
		result = FALSE;
#line 92 "../src/PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 92 "../src/PluginManager.vala"
		_g_module_close0 (module);
#line 92 "../src/PluginManager.vala"
		_g_free0 (path);
#line 92 "../src/PluginManager.vala"
		return result;
#line 689 "PluginManager.c"
	}
#line 95 "../src/PluginManager.vala"
	_tmp16_ = info;
#line 95 "../src/PluginManager.vala"
	_tmp17_ = _tmp16_.name;
#line 95 "../src/PluginManager.vala"
	_tmp18_ = info;
#line 95 "../src/PluginManager.vala"
	if (!gala_plugin_manager_check_provides (self, _tmp17_, _tmp18_.provides)) {
#line 96 "../src/PluginManager.vala"
		result = FALSE;
#line 96 "../src/PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 96 "../src/PluginManager.vala"
		_g_module_close0 (module);
#line 96 "../src/PluginManager.vala"
		_g_free0 (path);
#line 96 "../src/PluginManager.vala"
		return result;
#line 709 "PluginManager.c"
	}
#line 99 "../src/PluginManager.vala"
	_tmp19_ = g_strdup (plugin_name);
#line 99 "../src/PluginManager.vala"
	_g_free0 (info.module_name);
#line 99 "../src/PluginManager.vala"
	info.module_name = _tmp19_;
#line 100 "../src/PluginManager.vala"
	_tmp20_ = module;
#line 100 "../src/PluginManager.vala"
	g_module_make_resident (_tmp20_);
#line 102 "../src/PluginManager.vala"
	_tmp22_ = info;
#line 102 "../src/PluginManager.vala"
	if (_tmp22_.load_priority == GALA_LOAD_PRIORITY_DEFERRED) {
#line 725 "PluginManager.c"
		gboolean _tmp23_;
#line 102 "../src/PluginManager.vala"
		_tmp23_ = self->priv->_initialized;
#line 102 "../src/PluginManager.vala"
		_tmp21_ = !_tmp23_;
#line 731 "PluginManager.c"
	} else {
#line 102 "../src/PluginManager.vala"
		_tmp21_ = FALSE;
#line 735 "PluginManager.c"
	}
#line 102 "../src/PluginManager.vala"
	if (_tmp21_) {
#line 739 "PluginManager.c"
		GeeLinkedList* _tmp24_;
		GalaPluginInfo _tmp25_;
#line 103 "../src/PluginManager.vala"
		_tmp24_ = self->priv->load_later_plugins;
#line 103 "../src/PluginManager.vala"
		_tmp25_ = info;
#line 103 "../src/PluginManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, &_tmp25_);
#line 748 "PluginManager.c"
	} else {
		GalaPluginInfo _tmp26_;
#line 105 "../src/PluginManager.vala"
		_tmp26_ = info;
#line 105 "../src/PluginManager.vala"
		gala_plugin_manager_load_plugin_class (self, &_tmp26_);
#line 755 "PluginManager.c"
	}
#line 108 "../src/PluginManager.vala"
	result = TRUE;
#line 108 "../src/PluginManager.vala"
	gala_plugin_info_destroy (&info);
#line 108 "../src/PluginManager.vala"
	_g_module_close0 (module);
#line 108 "../src/PluginManager.vala"
	_g_free0 (path);
#line 108 "../src/PluginManager.vala"
	return result;
#line 767 "PluginManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/PluginManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 775 "PluginManager.c"
}

static void
gala_plugin_manager_load_plugin_class (GalaPluginManager* self,
                                       GalaPluginInfo* info)
{
	GalaPlugin* plugin = NULL;
	GalaPluginInfo _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GHashTable* _tmp3_;
	GalaPluginInfo _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GalaPlugin* _tmp7_;
	GalaPlugin* _tmp8_;
	GalaPluginInfo _tmp9_;
	const gchar* _tmp10_;
	GalaPluginInfo _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_;
#line 111 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/PluginManager.vala"
	g_return_if_fail (info != NULL);
#line 112 "../src/PluginManager.vala"
	_tmp0_ = *info;
#line 112 "../src/PluginManager.vala"
	_tmp1_ = g_object_new (_tmp0_.plugin_type, NULL);
#line 112 "../src/PluginManager.vala"
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
#line 112 "../src/PluginManager.vala"
	plugin = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GALA_TYPE_PLUGIN, GalaPlugin);
#line 113 "../src/PluginManager.vala"
	_tmp3_ = self->priv->plugins;
#line 113 "../src/PluginManager.vala"
	_tmp4_ = *info;
#line 113 "../src/PluginManager.vala"
	_tmp5_ = _tmp4_.module_name;
#line 113 "../src/PluginManager.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 113 "../src/PluginManager.vala"
	_tmp7_ = plugin;
#line 113 "../src/PluginManager.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 113 "../src/PluginManager.vala"
	g_hash_table_insert (_tmp3_, _tmp6_, _tmp8_);
#line 115 "../src/PluginManager.vala"
	_tmp9_ = *info;
#line 115 "../src/PluginManager.vala"
	_tmp10_ = _tmp9_.name;
#line 115 "../src/PluginManager.vala"
	_tmp11_ = *info;
#line 115 "../src/PluginManager.vala"
	_tmp12_ = _tmp11_.module_name;
#line 115 "../src/PluginManager.vala"
	g_debug ("PluginManager.vala:115: Loaded plugin %s (%s)", _tmp10_, _tmp12_);
#line 117 "../src/PluginManager.vala"
	_tmp13_ = self->priv->_initialized;
#line 117 "../src/PluginManager.vala"
	if (_tmp13_) {
#line 837 "PluginManager.c"
		GalaPluginInfo _tmp14_;
		const gchar* _tmp15_;
		GalaPlugin* _tmp16_;
#line 118 "../src/PluginManager.vala"
		_tmp14_ = *info;
#line 118 "../src/PluginManager.vala"
		_tmp15_ = _tmp14_.module_name;
#line 118 "../src/PluginManager.vala"
		_tmp16_ = plugin;
#line 118 "../src/PluginManager.vala"
		gala_plugin_manager_initialize_plugin (self, _tmp15_, _tmp16_);
#line 119 "../src/PluginManager.vala"
		gala_plugin_manager_recalculate_regions (self);
#line 851 "PluginManager.c"
	}
#line 112 "../src/PluginManager.vala"
	_g_object_unref0 (plugin);
#line 855 "PluginManager.c"
}

static void
_gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender,
                                                                     gpointer self)
{
#line 125 "../src/PluginManager.vala"
	gala_plugin_manager_recalculate_regions ((GalaPluginManager*) self);
#line 864 "PluginManager.c"
}

static void
gala_plugin_manager_initialize_plugin (GalaPluginManager* self,
                                       const gchar* plugin_name,
                                       GalaPlugin* plugin)
{
	GalaWindowManager* _tmp0_;
#line 123 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/PluginManager.vala"
	g_return_if_fail (plugin_name != NULL);
#line 123 "../src/PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 124 "../src/PluginManager.vala"
	_tmp0_ = self->priv->wm;
#line 124 "../src/PluginManager.vala"
	gala_plugin_initialize (plugin, _tmp0_);
#line 125 "../src/PluginManager.vala"
	g_signal_connect_object (plugin, "region-changed", (GCallback) _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed, self, 0);
#line 885 "PluginManager.c"
}

static gboolean
gala_plugin_manager_check_provides (GalaPluginManager* self,
                                    const gchar* name,
                                    GalaPluginFunction provides)
{
	gchar* message = NULL;
	gchar* _tmp0_;
	gboolean result;
#line 128 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../src/PluginManager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 129 "../src/PluginManager.vala"
	_tmp0_ = g_strdup ("Plugins %s and %s both provide %s functionality, using first one only");
#line 129 "../src/PluginManager.vala"
	message = _tmp0_;
#line 130 "../src/PluginManager.vala"
	switch (provides) {
#line 130 "../src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_OVERVIEW:
#line 908 "PluginManager.c"
		{
			const gchar* _tmp1_;
#line 132 "../src/PluginManager.vala"
			_tmp1_ = self->priv->_window_overview_provider;
#line 132 "../src/PluginManager.vala"
			if (_tmp1_ != NULL) {
#line 915 "PluginManager.c"
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 133 "../src/PluginManager.vala"
				_tmp2_ = message;
#line 133 "../src/PluginManager.vala"
				_tmp3_ = self->priv->_window_overview_provider;
#line 133 "../src/PluginManager.vala"
				g_warning (_tmp2_, _tmp3_, name, "window overview");
#line 134 "../src/PluginManager.vala"
				result = FALSE;
#line 134 "../src/PluginManager.vala"
				_g_free0 (message);
#line 134 "../src/PluginManager.vala"
				return result;
#line 930 "PluginManager.c"
			}
#line 136 "../src/PluginManager.vala"
			gala_plugin_manager_set_window_overview_provider (self, name);
#line 137 "../src/PluginManager.vala"
			result = TRUE;
#line 137 "../src/PluginManager.vala"
			_g_free0 (message);
#line 137 "../src/PluginManager.vala"
			return result;
#line 940 "PluginManager.c"
		}
#line 130 "../src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_SWITCHER:
#line 944 "PluginManager.c"
		{
			const gchar* _tmp4_;
#line 139 "../src/PluginManager.vala"
			_tmp4_ = self->priv->_window_switcher_provider;
#line 139 "../src/PluginManager.vala"
			if (_tmp4_ != NULL) {
#line 951 "PluginManager.c"
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 140 "../src/PluginManager.vala"
				_tmp5_ = message;
#line 140 "../src/PluginManager.vala"
				_tmp6_ = self->priv->_window_switcher_provider;
#line 140 "../src/PluginManager.vala"
				g_warning (_tmp5_, _tmp6_, name, "window switcher");
#line 141 "../src/PluginManager.vala"
				result = FALSE;
#line 141 "../src/PluginManager.vala"
				_g_free0 (message);
#line 141 "../src/PluginManager.vala"
				return result;
#line 966 "PluginManager.c"
			}
#line 143 "../src/PluginManager.vala"
			gala_plugin_manager_set_window_switcher_provider (self, name);
#line 144 "../src/PluginManager.vala"
			result = TRUE;
#line 144 "../src/PluginManager.vala"
			_g_free0 (message);
#line 144 "../src/PluginManager.vala"
			return result;
#line 976 "PluginManager.c"
		}
		default:
		{
#line 146 "../src/PluginManager.vala"
			break;
#line 982 "PluginManager.c"
		}
	}
#line 149 "../src/PluginManager.vala"
	result = TRUE;
#line 149 "../src/PluginManager.vala"
	_g_free0 (message);
#line 149 "../src/PluginManager.vala"
	return result;
#line 991 "PluginManager.c"
}

static void
_gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key,
                                                gconstpointer value,
                                                gpointer self)
{
#line 155 "../src/PluginManager.vala"
	gala_plugin_manager_initialize_plugin ((GalaPluginManager*) self, (const gchar*) key, (GalaPlugin*) value);
#line 1001 "PluginManager.c"
}

void
gala_plugin_manager_initialize (GalaPluginManager* self,
                                GalaWindowManager* _wm)
{
	GalaWindowManager* _tmp0_;
	GHashTable* _tmp1_;
#line 152 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/PluginManager.vala"
	g_return_if_fail (_wm != NULL);
#line 153 "../src/PluginManager.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 153 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 153 "../src/PluginManager.vala"
	self->priv->wm = _tmp0_;
#line 155 "../src/PluginManager.vala"
	_tmp1_ = self->priv->plugins;
#line 155 "../src/PluginManager.vala"
	g_hash_table_foreach (_tmp1_, _gala_plugin_manager_initialize_plugin_gh_func, self);
#line 156 "../src/PluginManager.vala"
	gala_plugin_manager_recalculate_regions (self);
#line 158 "../src/PluginManager.vala"
	gala_plugin_manager_set_initialized (self, TRUE);
#line 1028 "PluginManager.c"
}

void
gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self)
{
	GeeLinkedList* _tmp10_;
#line 161 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 1037 "PluginManager.c"
	{
		GeeLinkedList* _info_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _info_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _info_index = 0;
#line 162 "../src/PluginManager.vala"
		_tmp0_ = self->priv->load_later_plugins;
#line 162 "../src/PluginManager.vala"
		_info_list = _tmp0_;
#line 162 "../src/PluginManager.vala"
		_tmp1_ = _info_list;
#line 162 "../src/PluginManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 162 "../src/PluginManager.vala"
		_tmp3_ = _tmp2_;
#line 162 "../src/PluginManager.vala"
		_info_size = _tmp3_;
#line 162 "../src/PluginManager.vala"
		_info_index = -1;
#line 162 "../src/PluginManager.vala"
		while (TRUE) {
#line 1062 "PluginManager.c"
			gint _tmp4_;
			gint _tmp5_;
			GalaPluginInfo* info = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GalaPluginInfo* _tmp8_;
			GalaPluginInfo _tmp9_;
#line 162 "../src/PluginManager.vala"
			_info_index = _info_index + 1;
#line 162 "../src/PluginManager.vala"
			_tmp4_ = _info_index;
#line 162 "../src/PluginManager.vala"
			_tmp5_ = _info_size;
#line 162 "../src/PluginManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 162 "../src/PluginManager.vala"
				break;
#line 1080 "PluginManager.c"
			}
#line 162 "../src/PluginManager.vala"
			_tmp6_ = _info_list;
#line 162 "../src/PluginManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _info_index);
#line 162 "../src/PluginManager.vala"
			info = (GalaPluginInfo*) _tmp7_;
#line 163 "../src/PluginManager.vala"
			_tmp8_ = info;
#line 163 "../src/PluginManager.vala"
			_tmp9_ = *_tmp8_;
#line 163 "../src/PluginManager.vala"
			gala_plugin_manager_load_plugin_class (self, &_tmp9_);
#line 162 "../src/PluginManager.vala"
			__vala_GalaPluginInfo_free0 (info);
#line 1096 "PluginManager.c"
		}
	}
#line 166 "../src/PluginManager.vala"
	_tmp10_ = self->priv->load_later_plugins;
#line 166 "../src/PluginManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
#line 1103 "PluginManager.c"
}

GalaPlugin*
gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                const gchar* id)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GalaPlugin* _tmp2_;
	GalaPlugin* result;
#line 169 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/PluginManager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 170 "../src/PluginManager.vala"
	_tmp0_ = self->priv->plugins;
#line 170 "../src/PluginManager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 170 "../src/PluginManager.vala"
	_tmp2_ = _g_object_ref0 ((GalaPlugin*) _tmp1_);
#line 170 "../src/PluginManager.vala"
	result = _tmp2_;
#line 170 "../src/PluginManager.vala"
	return result;
#line 1128 "PluginManager.c"
}

/**
     * Iterate over all plugins and grab their regions, update the regions
     * array accordingly and emit the regions_changed signal.
     */
static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 177 "../src/PluginManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 177 "../src/PluginManager.vala"
	return _data8_;
#line 1142 "PluginManager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 177 "../src/PluginManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1152 "PluginManager.c"
		GalaPluginManager* self;
#line 177 "../src/PluginManager.vala"
		self = _data8_->self;
#line 177 "../src/PluginManager.vala"
		_data8_->regions = (g_free (_data8_->regions), NULL);
#line 177 "../src/PluginManager.vala"
		_g_object_unref0 (self);
#line 177 "../src/PluginManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 1162 "PluginManager.c"
	}
}

static void
_vala_array_add9 (XRectangle* * array,
                  gint* length,
                  gint* size,
                  XRectangle value)
{
#line 189 "../src/PluginManager.vala"
	if ((*length) == (*size)) {
#line 189 "../src/PluginManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 189 "../src/PluginManager.vala"
		*array = g_renew (XRectangle, *array, *size);
#line 1178 "PluginManager.c"
	}
#line 189 "../src/PluginManager.vala"
	(*array)[(*length)++] = value;
#line 1182 "PluginManager.c"
}

static void
__lambda13_ (Block8Data* _data8_,
             const gchar* name,
             GalaPlugin* plugin)
{
	GalaPluginManager* self;
	gint _tmp0_ = 0;
	MtkRectangle* _tmp1_;
#line 180 "../src/PluginManager.vala"
	self = _data8_->self;
#line 180 "../src/PluginManager.vala"
	g_return_if_fail (name != NULL);
#line 180 "../src/PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 181 "../src/PluginManager.vala"
	_tmp1_ = gala_plugin_get_region (plugin, &_tmp0_);
#line 1201 "PluginManager.c"
	{
		MtkRectangle* region_collection = NULL;
		gint region_collection_length1 = 0;
		gint _region_collection_size_ = 0;
		gint region_it = 0;
#line 181 "../src/PluginManager.vala"
		region_collection = _tmp1_;
#line 181 "../src/PluginManager.vala"
		region_collection_length1 = _tmp0_;
#line 181 "../src/PluginManager.vala"
		for (region_it = 0; region_it < region_collection_length1; region_it = region_it + 1) {
#line 1213 "PluginManager.c"
			MtkRectangle region = {0};
#line 181 "../src/PluginManager.vala"
			region = region_collection[region_it];
#line 1217 "PluginManager.c"
			{
				XRectangle rect = {0};
				MtkRectangle _tmp2_;
				MtkRectangle _tmp3_;
				MtkRectangle _tmp4_;
				MtkRectangle _tmp5_;
				XRectangle _tmp6_ = {0};
#line 182 "../src/PluginManager.vala"
				_tmp2_ = region;
#line 182 "../src/PluginManager.vala"
				_tmp3_ = region;
#line 182 "../src/PluginManager.vala"
				_tmp4_ = region;
#line 182 "../src/PluginManager.vala"
				_tmp5_ = region;
#line 182 "../src/PluginManager.vala"
				_tmp6_.x = (gshort) _tmp2_.x;
#line 182 "../src/PluginManager.vala"
				_tmp6_.y = (gshort) _tmp3_.y;
#line 182 "../src/PluginManager.vala"
				_tmp6_.width = (gushort) _tmp4_.width;
#line 182 "../src/PluginManager.vala"
				_tmp6_.height = (gushort) _tmp5_.height;
#line 182 "../src/PluginManager.vala"
				rect = _tmp6_;
#line 189 "../src/PluginManager.vala"
				_vala_array_add9 (&_data8_->regions, &_data8_->regions_length1, &_data8_->_regions_size_, rect);
#line 1245 "PluginManager.c"
			}
		}
	}
}

static void
___lambda13__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 180 "../src/PluginManager.vala"
	__lambda13_ (self, (const gchar*) key, (GalaPlugin*) value);
#line 1258 "PluginManager.c"
}

static XRectangle*
_vala_array_dup1 (XRectangle* self,
                  gssize length)
{
#line 193 "../src/PluginManager.vala"
	if (length > 0) {
#line 193 "../src/PluginManager.vala"
		return g_memdup2 (self, length * sizeof (XRectangle));
#line 1269 "PluginManager.c"
	}
#line 193 "../src/PluginManager.vala"
	return NULL;
#line 1273 "PluginManager.c"
}

static void
gala_plugin_manager_recalculate_regions (GalaPluginManager* self)
{
	Block8Data* _data8_;
	XRectangle* _tmp0_;
	GHashTable* _tmp1_;
	XRectangle* _tmp2_;
	gint _tmp2__length1;
#line 177 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/PluginManager.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 177 "../src/PluginManager.vala"
	_data8_->_ref_count_ = 1;
#line 177 "../src/PluginManager.vala"
	_data8_->self = g_object_ref (self);
#line 178 "../src/PluginManager.vala"
	_tmp0_ = g_new0 (XRectangle, 0);
#line 178 "../src/PluginManager.vala"
	_data8_->regions = _tmp0_;
#line 178 "../src/PluginManager.vala"
	_data8_->regions_length1 = 0;
#line 178 "../src/PluginManager.vala"
	_data8_->_regions_size_ = _data8_->regions_length1;
#line 180 "../src/PluginManager.vala"
	_tmp1_ = self->priv->plugins;
#line 180 "../src/PluginManager.vala"
	g_hash_table_foreach (_tmp1_, ___lambda13__gh_func, _data8_);
#line 193 "../src/PluginManager.vala"
	_tmp2_ = (_data8_->regions != NULL) ? _vala_array_dup1 (_data8_->regions, _data8_->regions_length1) : _data8_->regions;
#line 193 "../src/PluginManager.vala"
	_tmp2__length1 = _data8_->regions_length1;
#line 193 "../src/PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 193 "../src/PluginManager.vala"
	self->priv->_regions = _tmp2_;
#line 193 "../src/PluginManager.vala"
	self->priv->_regions_length1 = _tmp2__length1;
#line 193 "../src/PluginManager.vala"
	self->priv->__regions_size_ = self->priv->_regions_length1;
#line 194 "../src/PluginManager.vala"
	g_signal_emit (self, gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL], 0);
#line 177 "../src/PluginManager.vala"
	block8_data_unref (_data8_);
#line 177 "../src/PluginManager.vala"
	_data8_ = NULL;
#line 1322 "PluginManager.c"
}

gboolean
gala_plugin_manager_get_initialized (GalaPluginManager* self)
{
	gboolean result;
#line 20 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/PluginManager.vala"
	result = self->priv->_initialized;
#line 20 "../src/PluginManager.vala"
	return result;
#line 1335 "PluginManager.c"
}

static void
gala_plugin_manager_set_initialized (GalaPluginManager* self,
                                     gboolean value)
{
	gboolean old_value;
#line 20 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/PluginManager.vala"
	old_value = gala_plugin_manager_get_initialized (self);
#line 20 "../src/PluginManager.vala"
	if (old_value != value) {
#line 20 "../src/PluginManager.vala"
		self->priv->_initialized = value;
#line 20 "../src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY]);
#line 1353 "PluginManager.c"
	}
}

const gchar*
gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/PluginManager.vala"
	_tmp0_ = self->priv->_window_switcher_provider;
#line 27 "../src/PluginManager.vala"
	result = _tmp0_;
#line 27 "../src/PluginManager.vala"
	return result;
#line 1370 "PluginManager.c"
}

static void
gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self,
                                                  const gchar* value)
{
	gchar* old_value;
#line 27 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/PluginManager.vala"
	old_value = gala_plugin_manager_get_window_switcher_provider (self);
#line 27 "../src/PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1384 "PluginManager.c"
		gchar* _tmp0_;
#line 27 "../src/PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/PluginManager.vala"
		_g_free0 (self->priv->_window_switcher_provider);
#line 27 "../src/PluginManager.vala"
		self->priv->_window_switcher_provider = _tmp0_;
#line 27 "../src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY]);
#line 1394 "PluginManager.c"
	}
}

const gchar*
gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/PluginManager.vala"
	_tmp0_ = self->priv->_window_overview_provider;
#line 28 "../src/PluginManager.vala"
	result = _tmp0_;
#line 28 "../src/PluginManager.vala"
	return result;
#line 1411 "PluginManager.c"
}

static void
gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self,
                                                  const gchar* value)
{
	gchar* old_value;
#line 28 "../src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/PluginManager.vala"
	old_value = gala_plugin_manager_get_window_overview_provider (self);
#line 28 "../src/PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1425 "PluginManager.c"
		gchar* _tmp0_;
#line 28 "../src/PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/PluginManager.vala"
		_g_free0 (self->priv->_window_overview_provider);
#line 28 "../src/PluginManager.vala"
		self->priv->_window_overview_provider = _tmp0_;
#line 28 "../src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY]);
#line 1435 "PluginManager.c"
	}
}

static void
gala_plugin_manager_class_init (GalaPluginManagerClass * klass,
                                gpointer klass_data)
{
#line 7 "../src/PluginManager.vala"
	gala_plugin_manager_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/PluginManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginManager_private_offset);
#line 7 "../src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugin_manager_get_property;
#line 7 "../src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugin_manager_set_property;
#line 7 "../src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugin_manager_finalize;
#line 7 "../src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY] = g_param_spec_string ("window-switcher-provider", "window-switcher-provider", "window-switcher-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY] = g_param_spec_string ("window-overview-provider", "window-overview-provider", "window-overview-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/PluginManager.vala"
	gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL] = g_signal_new ("regions-changed", GALA_TYPE_PLUGIN_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1461 "PluginManager.c"
}

static void
gala_plugin_manager_instance_init (GalaPluginManager * self,
                                   gpointer klass)
{
	XRectangle* _tmp0_;
#line 7 "../src/PluginManager.vala"
	self->priv = gala_plugin_manager_get_instance_private (self);
#line 20 "../src/PluginManager.vala"
	self->priv->_initialized = FALSE;
#line 22 "../src/PluginManager.vala"
	_tmp0_ = g_new0 (XRectangle, 0);
#line 22 "../src/PluginManager.vala"
	self->priv->_regions = _tmp0_;
#line 22 "../src/PluginManager.vala"
	self->priv->_regions_length1 = 0;
#line 22 "../src/PluginManager.vala"
	self->priv->__regions_size_ = self->priv->_regions_length1;
#line 27 "../src/PluginManager.vala"
	self->priv->_window_switcher_provider = NULL;
#line 28 "../src/PluginManager.vala"
	self->priv->_window_overview_provider = NULL;
#line 33 "../src/PluginManager.vala"
	self->priv->wm = NULL;
#line 1487 "PluginManager.c"
}

static void
gala_plugin_manager_finalize (GObject * obj)
{
	GalaPluginManager * self;
#line 7 "../src/PluginManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 22 "../src/PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 27 "../src/PluginManager.vala"
	_g_free0 (self->priv->_window_switcher_provider);
#line 28 "../src/PluginManager.vala"
	_g_free0 (self->priv->_window_overview_provider);
#line 30 "../src/PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 31 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 33 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 35 "../src/PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 111 "../src/PluginManager.vala"
	G_OBJECT_CLASS (gala_plugin_manager_parent_class)->finalize (obj);
#line 1512 "PluginManager.c"
}

 G_GNUC_NO_INLINE static GType
gala_plugin_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugin_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginManager), 0, (GInstanceInitFunc) gala_plugin_manager_instance_init, NULL };
	GType gala_plugin_manager_type_id;
	gala_plugin_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaPluginManager", &g_define_type_info, 0);
	GalaPluginManager_private_offset = g_type_add_instance_private (gala_plugin_manager_type_id, sizeof (GalaPluginManagerPrivate));
	return gala_plugin_manager_type_id;
}

GType
gala_plugin_manager_get_type (void)
{
	static gsize gala_plugin_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_plugin_manager_type_id__once)) {
		GType gala_plugin_manager_type_id;
		gala_plugin_manager_type_id = gala_plugin_manager_get_type_once ();
		g_once_init_leave (&gala_plugin_manager_type_id__once, gala_plugin_manager_type_id);
	}
	return gala_plugin_manager_type_id__once;
}

static void
_vala_gala_plugin_manager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 7 "../src/PluginManager.vala"
	switch (property_id) {
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY:
#line 7 "../src/PluginManager.vala"
		g_value_set_boolean (value, gala_plugin_manager_get_initialized (self));
#line 7 "../src/PluginManager.vala"
		break;
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY:
#line 7 "../src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_switcher_provider (self));
#line 7 "../src/PluginManager.vala"
		break;
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY:
#line 7 "../src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_overview_provider (self));
#line 7 "../src/PluginManager.vala"
		break;
#line 1565 "PluginManager.c"
		default:
#line 7 "../src/PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/PluginManager.vala"
		break;
#line 1571 "PluginManager.c"
	}
}

static void
_vala_gala_plugin_manager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 7 "../src/PluginManager.vala"
	switch (property_id) {
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY:
#line 7 "../src/PluginManager.vala"
		gala_plugin_manager_set_initialized (self, g_value_get_boolean (value));
#line 7 "../src/PluginManager.vala"
		break;
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY:
#line 7 "../src/PluginManager.vala"
		gala_plugin_manager_set_window_switcher_provider (self, g_value_get_string (value));
#line 7 "../src/PluginManager.vala"
		break;
#line 7 "../src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY:
#line 7 "../src/PluginManager.vala"
		gala_plugin_manager_set_window_overview_provider (self, g_value_get_string (value));
#line 7 "../src/PluginManager.vala"
		break;
#line 1603 "PluginManager.c"
		default:
#line 7 "../src/PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/PluginManager.vala"
		break;
#line 1609 "PluginManager.c"
	}
}

